# 如何使用徽标数

> 徽标数一般出现在通知图标或头像的右上角，用于显示需要处理的消息条数，通过醒目视觉形式吸引用户处理

![徽标图1](./image/badge1.png ':size=100x60')
![徽标图2](./image/badge2.png ':size=220x60')
![徽标图3](./image/badge3.png ':size=60x60')

**插件示例**

``` java
Button btn= (Button)this.getView().getControl("button");
BadgeInfo info = new BadgeInfo();
info.setCount(10);
btn.setBadgeInfo(info);
```

**BadgeInfo对象方法**

方法名  | 参数  | 说明
-------|------|-----
**setCount**|Integer:count|设置数量
**setDot**|boolean:dot|设置是否显示成点,默认为false
**setColor**|String:color|设置显示颜色，如（#aaaaaa）
**setShowZero**|boolean:showZero|设置数量为0的时候是否显示，默认为false
**setOverflowCount**|Integer:overflowCount|超过 `overflowCount` 的会显示为 `${overflowCount}+`，默认的 `overflowCount` 为 99
**setOffset**|String[]:offset|设置显示的偏移修正量[right,top],如[10,10]

!> 目前支持设置徽标的控件有：*按钮*、*图片*、*字体图标*、*标签*、*工具栏*、*页签项*