# 如何调用移动端App接口

在移动端的轻应用的开发过程中，常常需要调用App的能力，如拍照，扫码等，在苍穹平台中提供了两种调用方式

1、`callClientAppMethod`方法

2、`executeClientCommand`方法

**callClientAppMethod方法**

?>callClientAppMethod(ClientMethod method,Object args)  
method：app方法名  
args：调用该app方法需要的参数

``` java
//调用扫描功能
MobileFormView view = (MobileFormView)this.getView();
view.callClientAppMethod(ClientMethod.ScanQRCode, null);

/**
    如调用该App方法会有回调，则进该事件
*/
@Override
public void customEvent(CustomEventArgs e) {
    String eventName = e.getEventName();
    String value = e.getEventArgs();
    String key = e.getKey();
    if(key.equals("callAppMethod") && eventName.equals(ClientMethod.ScanQRCode.getValue())){
       // you code
    }
}
```

**executeClientCommand方法**

?>executeClientCommand("callYZJApi", Map map);  
map：对象，包含method和args属性

```java
HashMap map = new HashMap();
map.put("method", "selectPic"); //selectPic 为云之家方法名
HashMap args = new HashMap();
args.put("type", "camera");
map.put("args", args);  //args 调用该云之家方法需要传递的参数
this.getView().executeClientCommand("callYZJApi", map);


/**
    如调用该App方法会有回调，则进该事件
*/
@Override
public void customEvent(CustomEventArgs e) {
    String eventName = e.getEventName();
    String value = e.getEventArgs();
    String key = e.getKey();
    if(key.equals("callAppMethod") && eventName.equals("selectPic")){
       // you code
    }
}
```

!>目前云之家App的大部分的方法可通过这两种方法调用，使用前需[参考云之家](https://open.yunzhijia.com/openplatform/resourceCenter/doc#/gitbook-wiki/app-open-api/UI.html)App方法。钉钉部分支持，后续完善; 企业微信在iOS上, 是调用APP能力, Android上, 调用H5的拍照能力