# 控件属性对照表
!> 描述了所有控件的属性，了解控件的属性，有助于控件的使用，同时方便在插件中动态修改控件的任意属性。
#### 通用属性
?> 通用属性是每一个控件共有的属性

属性名 | 属性ID | 描述 | 版本新增  
------- | ------- | ------- | ------- 
标识|id|控件的标识，通过它可获取到控件，`不能改动`
名称|| 控件名称
宽度|w|控件宽度
高度|h|控件高度
可见性|vi|设置控件是否可见
锁定性|l|设置控件是否可以编辑或者使用
字体大小|fs|设置控件内字体显示大小
前景色|fc|设置控件内字体颜色
背景色|bc|设置控件背景色
边框|b|设置控件边框样式，大小，颜色
内边距|p|设置控件内边距
外边距|m|设置控件外边距
扩展比例|gr
压缩比例|
堆叠样式|
自定义样式|cstyles|用于自定义该控件的样式|v1.5|

!>一个控件的属性除了在设计器上直接设置以外，所有的属性都是支持插件动态设置，平台提供了以下几种修改控件属性的方法

- **1、设计器直接设置**  
该方法是在设计器里面直接配置，简单易懂

- **2、使用控件方法设置**  
该方法是使用控件本身提供的方法设置，需要在插件调用，直接易懂，但目前并不是控件的所有属性都提供了方法，还覆盖不全，后续完善，如：

``` java
//设置html的内容
Html html = (Html)this.getView().getControl("progress");
html.setContent("<div>我是html<div>");
```
- **动态修改元数据**  
`this.getView().updateControlMetadata`该方法是一个终极全能方法，能动态修改控件任意属性，缺点是对使用者不够友好，需要清楚控件属性标识和值类型，如：

``` java
//修改面板折叠属性
Map<String, Object> data = new HashMap<String, Object>();
data.put(ClientProperties.Collapsible, true);
this.getView().updateControlMetadata("panel", data);

//修改标签前景色
Map<String, Object> ctrl = new HashMap<String, Object>();
ctrl.put(ClientProperties.ForeColor, "#aaaaaa");
this.getView().updateControlMetadata("labelap1",ctrl);

```

!>使用updateControlMetadata需了解每个控件的属性，具体属性ID和类型可以参考每个控件的说明

