# 主题定制

> 目前系统初始化5种预置的主题风格:blue(商务蓝)、green(清新绿)、orange(活力橙)、purple(典雅紫)、red(魅力红);这5种预置主题不可修改，但可禁用,同时还支持新增主题，增强了扩展能力

## 需求背景
- 之前系统只有预置的5种主题风格，且不可修改删除，灵活性差

![节点](./image/theme_origin.png ':size=250x400')
- 希望支持批量全局修改控件某些属性的功能，比如字段默认风格、默认布局等；


## 支持功能描述
- UI主题定制 - 包含主题相关色、定制化样式
- 控件默认属性修改

## 功能演示
在应用-配置工具-主题定制进行主题的定制，详见:

![节点](./image/dingzhi.gif)

## 操作步骤
- 管理员账号登录系统，进入应用配置，点击主题定制菜单

!>**注意:管理员才有权限进行配置**  

- 进入主题定制列表

- 点击新增按钮, 填写相关主题信息

- 一键保存

- 主页个人中心界面主题列表更新

![节点](./image/theme_add.png ':size=250x400')

- 其他功能介绍：
   - 启用主题: 新增的主题默认是启用状态，主题列表中必须至少包含一个启用状态的主题
   - 禁用主题: 禁用的主题不会出现在个人中心主题列表中,你可禁用掉默认主题以外的其他主题，这样系统仅支持一个主题，用户不可切换

   ![节点](./image/theme_delete.png ':size=250x400')
   - 默认主题: 主题列表中必须有且仅能有一个默认主题，默认主题不可被删除/禁用
   - 系统预设主题: 系统有五个预设主题，预设主题不能修改主题信息，仅能修改其默认属性
   - 修改主题: 非预设主题支持修改其编码、名称、主题内容及默认属性
   - 删除主题: 系统预设的主题和默认主题不能被删除



## 配置项说明
注: 在主题内容里面的内容需要为严格的JSON 格式，不能有任何其他的注释，各个项的配置说明[请参考](https://vip.kingdee.com/article/91102841573433856)

### 配置Demo
``` json
{
    "theme": {
        "@theme-color": "#5582F3"
    },
    "defaultProps": {
        "common": {
            "field": {
                "labelDirection": "h",
                "fieldStyle": 2,
                "textAlign": "right"
            }
        }
    }
}
```




