# 如何引入第三方JS

>**在二开过程中，标准产品的前端无法满足具体的业务需求开发时，需要引入其他的JS，面对该场景，苍穹平台提供了如下几种方式**

## 全局配置方式
使用管理员身份登录，然后 `系统管理` => `登录页配置` => `高级设置` => `下载模版`，解压后有两个文件`index.js`、`index_m.js`。
- **index.js** 用于扩展web端的页面
- **index_m.js** 用于扩展移动端页面

!>需要按照模版文件提供的方式进行扩展，其中提供了`window.afterLoaded`方法，用于指定在平台的js加载完成后才运行该扩展的js。

```js
(function(){
     //扩展的js默认是在平台的js前运行
     // do something
     console.log('xxx');
})();
```

```js
(function(){
     //扩展的js在平台的js加载完后运行
    window.afterLoaded = function (){
         // do something
        console.log('xxx');
     }
})();
```
最后把js文件压缩后上传，重新访问即可

## 插件动态插入方式

该方式只需在插件中，调用提供的api方式即可实现动态引入外部JS，如下：
```java
String jspath = "http://xxxx/xxx.js";
this.getView().executeClientCommand("loadThirdPartyJS", jspath)
```
**两种方式差异对比**

 差异项| 配置式 | 插件式 |  
------- | -------  | ------ 
**影响范围** | 全局 | 可全局，可指定页面，根据插件影响范围确定
**加载时机** | 页面初始化前 | 页面初始化后，执行插件时