# 如何通过URL参数访问指定页面

> 本篇将介绍如何配置url参数，访问指定表单、列表以及列表某一条记录的详情页面。

## PC端页面
> PC端的页面访问后缀为`index.html`
### 动态表单/单据新增页
 参数名| 描述
------- | ------- 
**formId** | 指定表单的标识，可在设计器表单页面找到‘(标识)’属性

例如，下面链接可以跳转到出差申请单页面  
`https://ip:port/ierp/index.html?formId=er_tripreqbill`

!>这里以及下面示例中的url地址是测试环境的地址，不一定可以访问的到。在实际操作的时候，需要换成其他对应的生产环境的地址。

### 列表页面
 参数名| 描述 
------- | ------- 
**type** | list，固定值
**formId** | 指定列表表单模版的值，可在设计器列表页面找到‘列表表单模版’属性
**billFormId** | 指定表单的标识，可在设计器表单页面找到‘(标识)’属性

例如，下面链接可以跳转到出差申请单的列表页面  
`https://ip:port/ierp/index.html?type=list&formId=bos_list&billFormId=er_tripreqbill`

### 列表指定记录详情页面
 参数名| 描述
------- | ------- 
**formId** | 指定列表表单模版的值，可在设计器列表页面找到‘列表表单模版’属性
**pkId** | 指定列表记录的id，需要在数据库中查找

例如，下面链接可以跳转到出差申请单列表某一条记录的录入页面  
`https://ip:port/ierp/index.html?formId=er_tripreqbill&pkId=721810009540800512`

## 移动端页面
> 移动端的页面访问后缀是 `mobile.html`

### 动态表单/单据新增页
 参数名| 描述
------- | ------- 
**form** | 指定表单的标识，可在设计器表单页面找到‘(标识)’属性

例如，下面链接可以跳转到出差申请单首页  
`https://ip:port/ierp/mobile.html?form=er_mainpage`

### 列表页面
 参数名| 描述
------- | ------- 
**type** | mobilelist，固定值
**form** | 指定列表表单模版的值，可在设计器列表页面找到‘列表表单模版’属性
**billFormId** | 指定表单的标识，可在设计器表单页面找到‘(标识)’属性

例如，下面链接可以跳转到移动端出差申请单的列表页面  
`https://ip:port/ierp/mobile.html?type=mobilelist&form=er_tripreqlisttemplate&billFormId=er_tripreqbill`

### 列表指定记录详情页面
 参数名| 描述
------- | ------- 
**form** | 指定列表表单模版的值，可在设计器列表页面找到‘列表表单模版’属性
**pkId** | 指定列表记录的id，需要在数据库中查找

例如，下面链接可以跳转到移动端出差申请单某一条记录的详情页面  
`https://ip:port/ierp/mobile.html?form=er_tripreqbill_mob&pkId=721810009540800512`