# Listbox控件
>一组抽屉菜单，响应用户点击行为，触发相应的业务逻辑。

## 控件对象
`kd.bos.ext.form.control.Listbox`

## 视觉展示
- **垂直**

![vertical.png](./image/vertical.png)

- **水平**

![level.png](./image/level.png)

## 属性说明

属性名 | 属性ID | 类型 | 默认值 | 说明 
:----: | :----: | :----: | :----: | :---- 
方向 | `dr` | String | `'v'` | 设置控件的显示风格

?> 控件通用属性[请参考](advanced/controlProperties/)

## 插件API
方法名 | 参数 | 说明  
------- | ------- | -------  
`addItems` | `List<ListboxItem>` | 动态添加子项  

## 插件示例

- **实现ListboxClickListener接口**
```java
public class TestPlugin extends AbstractFormPlugin implements ListboxClickListener {
  public void registerListener(EventObject event) {
  
    // 注册监听
    Listbox box = this.getView().getControl("控件标识");
    box.addListboxClickListener(this);
  }

  // 点击时触发
  public void listboxClick(ListboxEvnet event) {

  }
}
```  

- **动态添加子项**
```java
ListboxItem listboxItem1 = new ListboxItem("1", "菜单1");
ListboxItem listboxItem2 = new ListboxItem("2", "菜单2");
List<ListboxItem> itemlist = new ArrayList<>();
itemlist.add(listboxItem1);
itemlist.add(listboxItem2);
Listbox.addItems(itemlist);
```