# 工具栏
>包含一系列对单据操作的工具栏项的栏目，用于需要新增、查看、保存、删除单据等操作

## 控件对象
`kd.bos.form.control.Toolbar`

## 视觉展示
- **点击风格**：点按 按钮本身 发出`click`事件，点击右边的下三角弹出配置的下拉菜单。
- **下拉风格**：点按 按钮本身 不会发出 `click`事件，只会弹出配置的下拉菜单。
![baritemStyle.gif](./image/baritemStyle.gif)

- **工具栏项折叠模式为允许折叠到更多，则可在“更多”按钮的自定义里配置工具栏项是否折叠到“更多”的下拉菜单里**
![toolbarasmore.gif](./image/toolbarasmore.gif)

- **工具栏项折叠模式为固定到更多，则该工具栏项会折叠到“更多”按钮的下拉菜单里，并且不可通过自定义配置将其外置**
![toolbarfixedmore.gif](./image/toolbarfixedmore.gif)

## 工具栏属性说明
属性名 | 属性ID | 类型 | 默认值 | 说明 
:----: | :----: | :----: | :----: | :---- 
子项折叠 | `showmore` | boolean | `false` | 开启后允许将工具栏项放置在“更多”按钮中
请求动画 | `controlLoading` | boolean | `false` | 发送请求过程中开启加载动画

## 工具栏项属性说明
属性名 | 属性ID | 类型 | 默认值 | 说明 
:----: | :----: | :----: | :----: | :---- 
下拉菜单 | `items` | List | | 配置工具栏项下拉菜单的选项
提交校验 | `cv` | boolean | `false` | 前端字段必录校验
上传按钮 | `iu` | boolean | `false` | 是否允许弹出上传文件的窗口，开启后即可设置上传配置属性
上传配置 | `uconfig` | Map | | 设置上传文件窗口属性（大小、类型、地址、是否多选、临时存储），需`上传按钮`属性开启后才可配置此属性
操作代码 | `opk` | String | | 设置按钮点击时调用的操作（新增、删除、保存等）
交互风格 | `os` | number |  | 切换交互风格，可参考视觉展示
繁忙提示 | `busyTip` | Map |  | 配置长时间请求的提示信息
获取证书 | `tc` | boolean | `false` | 获取CA证书信息
折叠模式 | `morebuttonmodel` | String | `null` | 设置工具栏项的折叠模式，可参考视觉展示

?> 控件通用属性[请参考](advanced/controlProperties/)

## 插件示例
- **插件监听工具栏点击事件**

```java
public class TestPlugin extends AbstractFormPlugin implements ItemClickListener {
  public void registerListener(EventObject event) {
    Toolbar toolbar = this.getView().getControl("控件标识");
    toolbar.addItemClickListener(this);
  }
  
  // 点击发生前
  public void beforeItemClick(BeforeItemClickEvnet event) {
  
  }
  
  // 点击发生后
  public void itemClick(ItemClickEvent event) {
  
  }
}
```  
