# SpreadJS控件
>`SpreadJS `是一款基于 HTML5 的纯前端表格控件，兼容 450 种以上的 Excel 公式，具备“高性能、跨平台、与 Excel 高度兼容”的产品特性。SpreadJS 在界面和功能上与 Excel 高度类似，但又不局限于 Excel，而是为企业信息化建设提供表格文档协同编辑、数据填报和类Excel报表设计的功能支持

## 控件对象
`kd.bos.form.spread`

## 视觉展示


![编辑模式](./image/spread.PNG)



## 属性说明
属性名 | 属性ID | 类型 | 默认值 | 说明 
---- | :----: | :----: | :----: | :---- 
显示编辑工具栏 | `ShowEditToolBar` | bool | `true`| 是否显示`工具栏`
允许多页签 | `SupportMultipleTab` | bool | `false`| 单页签模式 , 多页签模式
支持导出excel | `ExportExcel` | bool | `false`| 生成两个`Spread`实例

控件通用属性[请参考](advanced/controlProperties/)

## 插件 API
接口名称 | 参数 | 说明  
------- | ------- | -------  
| callbackAction | {callback:, invokemethod:} | 回调函数指令，后端告诉前端它还有后续动作 |
| setSpreadJson | spreadJS压缩过后的json串 | 加载spreadJS的json串 |
| appendRows | {count:, si:} | 在指定工作表尾部追加count行/列<br>count: 行/列数（必填）<br>si: 指定工作表的索引，默认是当前工作表（可选） |
| setColumnsWidth/setRowsHeight | {index:[], num:, si,area} | 设置列宽/行高<br>index: 指定行（列）的索引（必填）<br>num: 宽度或高度（以像素为单位，必填）<br>si: 指定工作表的索引，默认是当前工作表（可选）<br>area: 指定区域 (可选) area的值有三种 colHeader(列头) rowHeader(行头) viewport(单元格区域) 默认是单元格区域 |
| getColumnsWidth/getRowsHeight | {index:[2,3], callback: 'invokeAction', invokemethod: 'invokemethod', si:} | 获取列宽/行高<br>index: 指定行（列）的索引（必填）<br>callback: 回调的请求方法名（必填）<br>invokemethod: invokemethod（必填）<br>si: 指定工作表的索引，默认是当前工作表（可选） |
| setRowsVisible | {rows: [1, 3], value: false, si:} | 设置行可见性<br>rows: 行的索引，是一个数组（必填）<br>value: 可见性 true || false（必填）<br>si: 指定工作表的索引，默认是当前工作表（可选） |
| setColumnsVisible | {cols: [2, 4], value: true, si:} | 设置列可见性<br>cols: 列的索引，是一个数组（必填）<br>value: 可见性 true || false（必填）<br>si: 指定工作表的索引，默认是当前工作表（可选） |
| lockSheet/unlockSheet | {si: [] } | 锁定/解锁工作表<br>si: 指定工作表的索引，默认是当前工作表（可选） |
| setSpan | {range:[{r:, c:, rc:, cc:}], si:} | 合并指定区域的单元格<br>range: 指定表格区域（必填）<br>si: 指定工作表的索引，默认是当前工作表（可选） |
| setCellStyle |{data:[{range: [{r:2, c:2, rc:2, cc:2}], style:{stf:true} }],si:} //指示内容是否收缩以适应<br>{data:[{range: [{r:2, c:2, rc:2, cc:2}], style:{ti:2} }],si:} //表示单元格中文本的缩进单元数(一个整数值)，其中增量1表示8个像素。| 设置单元格样式/格式<br>range: 指定表格区域（必填）<br>style: 设置样式信息（必填）<br>si: 指定工作表的索引，默认是当前工作表（可选）<br>1.   设置单元格边框中的bls表示边框线的样式，可以设置成：dashDot,dashDotDot,dashed,dotted,double,empty,hair,medium,mediumDashDot,mediumDashDotDot,mediumDashed,slantedDashDot,thick,thin。blc表示边框线的颜色。<br>2.   设置行头区域,列的索引设置为0;设置列头区域,行的索引设置成0;rc和cc一般设置成1; |
| fieldInsertRow | {range:{r:,c:,rc:,cc:,},index: ,count: ,styleIndex:, si: } | 在指定的工作表区域新增行/列，并复制指定行/列的样式<br>range: 指定表格区域（必填）<br>index: 指定插入的索引（必填）<br>count: 插入的行/列数（必填）<br>styleIndex：复制指定行/列样式的索引（必填）<br>si: 指定工作表的索引，默认是当前工作表（可选） |
| fieldInsertCol |  {range:{r:,c:,rc:,cc:,},index: ,count: ,styleIndex:, si: } | 在指定的工作表区域新增行/列，并复制指定行/列的样式<br>range: 指定表格区域（必填）<br>index: 指定插入的索引（必填）<br>count: 插入的行/列数（必填）<br>styleIndex：复制指定行/列样式的索引（必填）<br>si: 指定工作表的索引，默认是当前工作表（可选）  |
| fieldDeleteRow | {range:{r:,c:,rc:,cc:},index:,count:,si:} | 删除指定的工作表区域的行/列<br>range: 指定表格区域（必填）<br>index: 指定插入的索引（必填）<br>count: 插入的行/列数（必填）<br>si: 指定工作表的索引，默认是当前工作表（可选） |
| setFListCell | {cell:[{r:1,c:1}], selectType:0, dst:1,lockClickable：true}<br>或<br>{range: [{r:, c:, rc:, cc}], selectType:0, dst:1,lockClickable:true} | 设置f7类型单元格。<br>selectType: 0(支持模糊查询)，1(不支持模糊查询)<br>dst: 0(默认风格)，1(显示风格为下拉)<br>lockClickable：true(支持锁定状态下的点击) |
| setComboCell | [{cell:{r:,c:}, option:["a","b","c"]}] | 设置下拉列表类型单元格<br>cell: 指定单元格（必填）<br>option: 下拉项（必填） |
| setBtnCell | [{cell:{r:,c:},text:}] | 设置按钮类型单元格 |
| setCustomBtnCell |  [{cell:{r:,c:},text:}] | 设置自定义按钮类型单元格 |  
| setCellTag | [{r:, c:, st:true/false, pos:[0,2]}] | 给单元格设置特殊标识（小红点）<br>r: 指定行（必填）<br>c: 指定列（必填）<br>st：控制是否显示小红点（必填）<br>pos: 指定小红点的位置，0-3分别代表左上、右上、右下、左下（必填） |
| resetCell | {range:[{r:, c:, rc:, cc:}], si:} | 重置指定工作表区域的单元格类型<br>range: 指定工作表区域（必填）<br>si: 指定工作表的索引，默认是当前工作表（可选） |
| getSpreadJson | {callback:, invokemethod:} | 获得表格bsae64格式文件，回传请求指令和后台触发事件<br>callback: 回调的请求方法名（必填）<br>invokemethod: invokemethod（必填） |
| setLookupData | {r:,c:,data:} | 获取f7单元格类型的lookup数据 |
| setCustomFormulaCell | {cell:[{r:,c:}], si:} | 设置自定义的公式单元格 |
| setAllCustomFormulaCell | {si: } | 设置所有单元格都为自定义公式单元格 |
| registerCustomFormula | [{formulaName: ,argsNum:,returnType:,descriptionInfo:{description:,parameters:[{name:}]} }] | 注册自定义公式 |
| setSelections | {r:, c:, rc:, cc:, si:} | 设置指定工作表区域单元格选中(会跳转到指定页签的指定单元格) |
| exportExcelFile | {fileName:} | excel文件<br>fileName: 文件名（必填） |
| lockToolbarItems | [{name: 'LockCells', isLock: true|false}]<br>or {isLock: true|false} | 锁定工具栏的某些操作，第二种参数是锁定整个工具栏<br>name: (原有功能)<br>* name: FontStyle(字体样式)、FontDecoration(加粗、斜体、下划线)、ForeAndBackColor(前后背景色)、CellsBorder(设置边框)、ClearCells(清除单元格)、CellFormat(单元格格式)、WordWrap(自动换行)<br>* name: TextAlign(文本对齐)、TextIndent(文本缩进)、LockCells(锁定单元格)、MergeCells(合并单元格)、Find (查找)、FormatPainter(格式刷)、Setting(显示锁定单元格) Undo(撤销) 、VerticalAlign(垂直对齐)<br>* name: InsertRowAndCol(插入和删除行列)、FrozenSheets(冻结窗体)、UploadFile(导入)、ExportFile(导出)、SwitchView(切换视图)、Print(打印)、SortAndFilter(过滤器) |
| hideContextMenuItems | [{name: , isHide: ,subMenu}]<br>or {isHide: true/false} | 隐藏或显示上下文菜单的某些功能，第二种参数是隐藏所有上下文菜单<br>name: copy(复制)、cut(剪切)、pasteOptions(粘贴选项)、<br>pasteAll(全部粘贴)、pasteFormula(公式)、pasteValues(值)、pasteFormatting(格式)、pasteValuesFormatting(值&amp;格式)、pasteFormulaFormatting(公式&amp;格式)、clearContents(清除)、insertRows(插入行)、insertColumns(插入列)、deleteRows(删除行)、deleteColumns(删除列)、insertSheet(插入表)、<br>insertRowMany 插入多行 |
| setViewOptions | [{type: ,text: ,baseType: }] | 设置当前工作表的视图 |
| print | {index:,printInfo:[{index:[],info:{}}]} | 打印spread表格 |
| clearCellsStyle | [{r:,c:,rc:,cc:}] | 清除单元格格式 |
| controlToolbarItems | [{name: 工具栏按钮名称, isCtl: true/false}] | 设置需要跟后端交互的工具栏按钮 |


## 插件示例

```java
 public class Spread extends Container{

	private SpreadPostDataInfo postData ;
	
	public void deleteRows(List<Integer> postDatas){
		packInvokeListParams(postDatas);
		this.getActionService().deleteRows(new SpreadEvent(this,postData));
	}
	
	public void deleteColumns(List<Integer> postDatas){
		packInvokeListParams(postDatas);
		this.getActionService().deleteColumns(new SpreadEvent(this,postData));
	}
	
	public void addRows(List<Integer> postDatas){
		packInvokeListParams(postDatas);
		this.getActionService().addRows(new SpreadEvent(this,postData));
	}
	
	public void addColumns(List<Integer> postDatas){
		packInvokeListParams(postDatas);
		this.getActionService().addColumns(new SpreadEvent(this,postData));
	}
	
	public void entryRowClick(int arg){
		getActionService().selectedSpread(new SpreadEvent(this,postData));	
	}
	
	public void askExecute(LinkedHashMap<String,Object> postDatas){
		packInvokeParams(postDatas);
		getActionService().askExecute(new SpreadEvent(this,postData));
	}
```  