# 客户端Ajax
> 用于当需要向通过客户端往第三方服务发送Ajax请求时

## 控件对象
`kd.bos.form.control.ClientAjax`

## 属性说明
属性名 | 属性ID | 类型 | 默认值 | 说明 
:---- | :----: | :----: | :----: | ---- 
Ajax请求URL | ajaxUrl | String | | 设置请求的目标地址，可设计时配置，也可插件中动态设置

?> 控件通用属性[请参考](advanced/controlProperties/)

## 插件示例
- **插件设置ajax请求参数，并发送ajax请求**

```java
ClientAjax ajax = this.getView().getControl("控件标识");

ClientAjaxOption option = new ClientAjaxOption();

option.setUrl("url链接"); // 请求链接
option.setAsync(true);  // 是否异步
option.setData("数据");  // 请求数据
option.setDataType("数据类型");  // 数据类型
option.setType("请求类型");  // 请求类型：get、post
// ...
ajax.request(option); // 发送指令
```
- **插件监听响应**

```java
public class TestPlugin extends AbstractFormPlugin implements ResponseListener {
  public void regiterListener(EventObject event) {
    ClientAjax ajax = this.getView().getControl("控件标识");
    ajax.addResponseListener(this); 
  }
  
  public void afterReceiveResponse(ResponseEvent event) {
    // do something...
  }
}

```  
