# 音频控件
>用于在单据页面播放音频文件。

## 控件对象
`kd.bos.ext.form.control.Audio`

## 视觉展示

- **默认外观** `(注: 该播放器基于web原生实现,在不同浏览器下外观可能略不同)`

![default.png](./image/audio_control_no_source.png) 

- **加载(音频)文件播放** 

![playing.png](./image/audio_control_playing.png) 


## 控件属性说明

属性名 | 属性ID | 类型 | 说明 
---- | :----: | :----: | ---- 
文件路径 | `src` | string | 音频文件路径 (相对/绝对路径都支持)
自动播放 | `autoPlay` | bool | 属性打开后，控件将设定的文件源自动播放音频

控件通用属性请参考=>[传送门](advanced/controlProperties/)

## 功能说明

功能名 | 说明
------- | ------- 
播放音频 | 根据设定的文件地址，播放音频内容(对音频格式有要求，具体请看`支持音频格式`章节)

## 支持音频格式

音频类型 | 音频编码 | 浏览器版本要求
---- | :----: | ----
Ogg(`ogg`) |  | 'Chrome 6+', 'Firefox 3.6+', 'Opera 10+'
Wav(`wav`) |  | 'Chrome 6+', 'Firefox 3.6+', 'Safari 5+', 'Opera 10+'
MP3(`mp3`) |  | 'IE 9+', 'Chrome 6+', 'Firefox 3.6+', 'Safari 5+', 'Opera 10+'

## 其他说明

- pc端/移动端都有音频播放控件
- 该控件隐藏之后，依然可以正常播放

## 插件示例

- **插件代码**

```java
public void do() {
    // 设置音频数据源
    Audio audioCtl = this.getView().getControl("控件id");
    audioCtl.setSrc("https://www.kingdee.com/kindee/audio/kingdee1.mp3");

    // 设置自动播放
    Map<String, Object> dataMap = new HashMap<>();
    dataMap.put("autoPlay", true); //设置为自动播放
    dataMap.put("k", "控件id");
    IClientViewProxy proxy = this.getView().getService(IClientViewProxy.class);
    proxy.addAction(ClientActions.updateControlStates, dataMap);
}
```  

