# 按钮
> 用于开始一个即时操作,标记了一个（或封装一组）操作命令，响应用户点击行为，触发相应的业务逻辑

## 控件对象
`kd.bos.form.control.Button`

## 视觉展示

![缺省](./image/default.png)
![文本](./image/textstyle.png)
![上图下文](./image/picstyle_v.png)
![左图右文](./image/picstyle_h.png)

## 属性说明

属性名 | 属性ID | 类型 | 默认值 | 说明 
:---- | :----: | :----: | :----: | ---- 
按钮样式 | `btns` | number | `1` | 切换按钮不同风格样式，图文风格时可设置位图标识、图片高度、图片宽度
位图标识 | `imageKey` | String |  | 设置图片的资源路径，需`按钮样式`属性为图文风格时才可配置此属性
图片高度 | `imgWidth` | String |  | 设置图片高度
图片宽度 | `imgHeight` | String |  | 设置图片宽度
提交校验 | `cv` | boolean | `false` | 点击触发前端字段必录校验
上传按钮 | `iu` | boolean | `false` | 设置控件是否允许弹出上传文件的窗口，开启后即可设置上传配置属性
上传配置 | `uconfig` | Map |  | 设置上传文件窗口属性（大小、类型、地址、是否多选、临时存储），需`上传按钮`属性开启后才可配置此属性
操作代码 | `operationKey` | String |  | 设置系统统一提供的操作
繁忙提示 | `busyTip` | Map |  | 设置长时间请求的提示信息
获取证书 | `tc` | boolean | `false` | 获取CA证书信息
显示tips | `tips` | Map |  | 设置提示信息，在控件右侧有个问号图标，支持点击和悬停显示设置的提示内容
跟随主题色 | `followTheme` | boolean | `false` | 按钮背景色跟随主题色 
请求动画 | `controlLoading` | boolean | `false` | 发送请求过程中开启加载动画

?> 控件通用属性[请参考](advanced/controlProperties/)

## 插件示例
- **插件中监听按钮 `click` 事件**
```java
public class TestPlugin extends AbstractFormPlugin implements ClickListener {
  public void regiterListener(EventObject e){
    // 1.注册监听
    Button btn = this.getView().getControl("按钮标识");
    btn.addClickListener(this);
  }
  
  public void click(EventObject e) {
   // 2. 响应方法，do something...
    Control control = (Control) evt.getSource();
    String key = control.getKey();
    if ("按钮标识".equals(key)) {
      // do some cool thing...
    }
  }
}
```  
