# 代码编辑器
> 用于代码编辑，能够根据选择的文件类型来使关键字高亮

## 控件对象
`kd.bos.form.control.CodeEdit`

## 视觉展示
- **eclipse主题**

![eclipse风格](./image/eclipse.PNG)

- **monokai主题**

![monokai风格](./image/monokai.PNG)

## 属性说明
属性名 | 属性ID | 类型 | 默认值 | 说明  
:-------: | :---: | :-------: |:------: | ----- 
文件类型 | `fileType` | String | `javascript` | 目前支持`javascript`、`java`、`markdown`、`xml`、`sql`语法高亮
主题  | `theme` | String | `eclipse` | 目前支持`eclipse`、`monokai`、`material`、`idea`、`dracula`主题
显示行号  | `sln` | boolean | `false` | 
显示复制按钮  | `scb` | boolean | `false` | 是否在右上角显示复制代码按钮
内容加密传输| `contentencode` | boolean | `false` | 开启后内容会经过base64编码传输，避免出现网络拦截
发送框选值  | `sendSelection` | boolean | `false` | 开启后支持光标选中值发送到后端

## 插件示例
- **插件设置和获取代码编辑器的内容**

```java
CodeEdit edit = this.getView().getControl("控件标识");
// 设置内容
edit.setText("要设置的内容");

// 获取内容
edit.getText();
```  
