# 倒计时
> 时间倒计时，常用于显示验证码有效时间、活动剩余时间等

## 控件对象
`kd.bos.ext.form.control.CountDown`

## 视觉展示

![倒计时](./image/countdown.gif)

## 属性说明
属性名 | 属性ID | 类型 | 默认值 | 说明 
:----: | :----: | :----: | :----: | ---- 
掩码 | `mask` | String | `hh-mm-ss` |根据掩码配置倒计时控件显示内容，例如hh-mm-ss、hh-mm、mm-ss

?> 控件通用属性[请参考](advanced/controlProperties/)

## 插件 API
接口名称 | 参数 | 说明  
------- | ------- | -------  
`setDuration` | `int` | 设置倒计时时长，单位为秒，设置后会自动开启倒计时
`pause` | 无 | 暂停倒计时
`start` | 无 | 启动倒计时

## 插件示例
- **设置倒计时时间、暂停倒计时、启动倒计时**
```java
CountDown countdown = this.getView().getControl('控件标识');
// 设置倒计时时间为70秒
countdown.setDuration(70);
// 暂停倒计时
countdown.pause()
// 启动倒计时
countdown.start()
```  
