# 图片列表
>当需要上传一个或一组图片时，可选择本地图片的控件。

## 运行时对象
`kd.bos.form.control.ImageList`

## 视觉展示
![multiImg.png](./image/multiImg.png)

## 属性说明
属性名 | 属性ID | 类型 | 默认值 | 说明  
:----: | :----: | :----: | :----: | ----
多图 | `multiImg` | boolean | `true` | 设置字段是否支持多张图片
允许上传 | `uploadImg` | boolean | `true` | 设置`Upload` 按钮是否出现 
最大图片数 | `maximgsize` | number | `-1` | 设置限制上传最大图片数，为负则不限制
显示图片名称 | `showName` | boolean | `false` | 设置是否显示图片名称

?> 控件通用属性[请参考](advanced/controlProperties/)

## 插件示例
- **插件中可动态设置图片**

```java
ImageList imageList = this.getView().getControl("控件标识");
String[] urls = new String[]{"", ""};
imageList.setImageUrls(urls);
```  

- **插件中监听上传/删除图片事件**

```java
public class Test extends AbstractPlugin implements UploadListener {
  public void regiterListener(EventObject e){
    // 1.注册监听
    ImageList image = this.getView().getControl("控件标识");
    image.addUploadListener(this);
  }
  
  // 上传完成后触发
  public void upload(UploadEvent event) {
    
  }
  
  // 删除完成后触发
  public void remove(UploadEvent event) {
  
  }
}
```  
