# 标签
>用于展示纯文本内容、标记出重要的内容、分类

## 控件对象
`kd.bos.form.control.Label`

## 视觉展示
![标签](./image/label.PNG)

## 属性说明

属性名 | 属性ID | 类型 | 默认值 | 说明 
:----: | :----: | :----: | :----: | ---- 
允许点击 | `clickable` | boolean | `false` | 设置标签是否允许点击
上传按钮 | `iu` | boolean | `false` | 设置控件是否允许弹出上传文件的窗口，开启后即可设置上传配置属性，需`允许点击`属性开启后才能配置此属性
上传配置 | `uconfig` | Map | | 配置上传文件窗口属性（大小、类型、地址、是否多选、临时存储），需`上传按钮`属性开启后才能配置此属性
操作代码 | `operationKey` | String | | 配置系统统一提供的操作，需`允许点击`属性开启后才能配置此属性
显示tips | `tips` | Map | | 设置提示信息，在控件右侧有个问号图标，支持点击和悬停显示设置的提示内容
请求动画 | `controlLoading` | boolean | `false` | 发送请求过程中开启加载动画，需`允许点击`属性开启后才能配置此属性
标签风格 | `labelStyle` | String | `"1"` | 设置标签控件展现风格，分为块状（`"2"`）和文本（`"1"`）
文本对齐方式 | `text-align` | String | `"left"` |设置标签文本的水平对齐方式
自动换行 | `stw` | boolean | `false` | 设置内容根据宽度自动换行

?> 控件通用属性[请参考](advanced/controlProperties/)

## 插件示例

- **标签可点击时，插件监听范例**
```java
public class TestPlugin extends AbstractFormPlugin implements ClickListener {
  public void regiterListener(EventObject e){
    // 1.注册监听
    Label label = this.getView().getControl("控件标识");
    label.addClickListener(this);
  }

  public void click(EventObject e) {
   // 2. 响应方法，do something...
    Control control = (Control) evt.getSource();
    String key = control.getKey();
    if ("控件标识".equals(key)) {
      // do some cool thing...
    }
  }
}
```

- **设置标签文本内容**
```java
Label label = this.getView().getControl("控件标识");
label.setText("这是一段文本内容");
```

