# Markdown控件
>`Markdown`语法的编辑器，支持预览模式和编辑模式

## 控件对象
`kd.bos.ext.form.control.Markdown`

## 视觉展示

- **编辑模式**

![编辑模式](./image/edit.PNG)

- **预览模式**

![预览模式](./image/preview.PNG)

## 属性说明
属性名 | 属性ID | 类型 | 默认值 | 说明 
---- | :----: | :----: | :----: | :---- 
模式 | `model` | number | `0`| 可切换控件模式，支持预览模式（`1`）、编辑模式（`0`）

?> 控件通用属性[请参考](advanced/controlProperties/)

## 插件 API
接口名称 | 参数 | 说明  
------- | ------- | -------  
`getText` | 无 | 获取控件内容  
`setText` | `String` | 设置控件内容
`setLinkData` | `List<MarkdownLinkData>` | 设置自定义链接数据
`setModelType` | `ModelType` | 设置控件模式


## 插件示例
- **支持自定义超链接**

```java
Markdown mk = this.getView().getControl("markdownap");
/**
* 在markdown文档中插入链接 遵循这个格式： [百度](https://www.baidu.com \"0\")
* “百度”是连接名，括号里面包含两部分，两部分用中间用 两个空格 隔开。 
* 前半部分是链接地址，外部地址必须以http或者https开头
* 内部地址可以直接写指令名如：[下一步](next \"1\")
* 后半部分是数据索引，只能输入string，所以需要转义。
*/
StringBuffer str = new StringBuffer(); // [百度](https://www.baidu.com \"0\")
str.append("# 测试链接").append(Markdown.Warp).append("[下一步](next \"1\")");
mk.setText(str.toString());

/**
* 构造链接数据
* 第一个参数是指令名，第二参数是数据索引，和上文中的索引对应
*/
List<MarkdownLinkData> data = new ArrayList<>();
data.add(new MarkdownLinkData("https://www.baidu.com", 0));
data.add(new MarkdownLinkData("next", 1));
mk.setLinkData(data);
```  