# 进度条
>用来展示进度的控件，常用场景：  
1、在操作需要较长时间才能完成时，为用户显示该操作的当前进度和状态。  
2、定时器或轮询，将进度条隐藏后并设定刷新间隔，定时去请求后台接口来执行特定的操作，比如刷新页面等。

## 控件对象
`kd.bos.form.control.ProgressBar`

## 视觉展示

![stripstyle.png](./image/stripstyle.png)
![roundstyle.png](./image/roundstyle.png)

## 属性说明

属性名 | 属性ID | 类型 | 默认值 | 说明  
:----:  | :----: | :----: | :----: | ----
刷新间隔时间 | `itime` | number |  | 设置每间隔多少毫秒刷新一次进度条
显示风格 | `pbs` | number | `0` | 设置进度条的显示风格

?> 控件通用属性[请参考](advanced/controlProperties/)

## 插件示例
- **API**

方法名 | 参数 | 说明  
------- | ------- | -------  
`start` | 无 | 进度条开始按照设置好的时间间隔刷新  
`stop` | 无 | 精度条停止发出请求  
`setPercent` | `int` 百分比 | 设置进度条进度
`setPercent` |`(int,String)`  百分比, 内容 | 设置进度条进度和提示内容

- **启动进度条、设置百分比事件** 

```java
// 插件实现「ProgresssListener」 接口
public class TestPlugin extends AbstractFormPlugin implements ProgresssListener {
  public void registerListener(EventObject event) {
    ProgressBar bar = this.getView().getControl("控件标识");
    bar.addProgressListener(this);
  }
  // 启动进度条
	public void start(){
		run(true);
	}
	
	// 停止进度条
	public void stop(){
		run(false);
	}

  // 每次刷新时进入该方法
  public void onProgress(ProgressEvent event) {
  
  }
}
```

!> 进度条必须调用start方法才可启动，开始按照设置好的时间间隔刷新
