# 富文本编辑器
> 当需要进行图文混排，在文字内进行插入表情、修改样式、进行排版、嵌入表格以及显示代码等功能时使用

## 控件对象
`kd.bos.form.control.RichTextEdit`

## 视觉展示
- **通用风格**

![通用风格](./image/richText.PNG)

- **精简风格**

![精简风格](./image/simpleText.PNG)

## 属性说明
属性名 | 属性ID | 类型 | 默认值 | 说明  
:------- | :---: | :-------: | :----: | :------ 
编辑器风格 | `rtes` | number | `0` | 通用风格（默认）提供全面的编辑器功能，精简风格（1）仅提供数种常用功能 
自动保存  | `autosave` | boolean | `false` | 停止操作编辑器两秒后，会自动保存一次已经编辑的内容
内容加密传输| `contentencode` | boolean | `false` | 内容会经过base64编码传输，避免出现网络拦截
锁定可打印预览 | `ilp` | boolean | `false` | 锁定情况下可打印和预览
设置功能 |  |  |  | 可按需配置工具栏功能

## 插件API

- **插件设置和获取富文本内容**

```java
RichTextEdit edit = this.getView().getControl("控件标识");
// 设置内容
edit.setText("要设置的内容");

// 获取内容
edit.getText();
```  

- **开启自动保存后，插件需要再customEvent中获取富文本的内容**

```java
@Override
public void customEvent(EventObject e) {
  super.customEvent(e);
  String args = e.getEventArgs();  // 富文本内容
}
```
