# 搜索控件

>用于页面需要搜索的场景，可通过鼠标或键盘输入内容查询数据，其中数据返回需要插件实现。

## 控件对象

`kd.bos.form.control.Search`

## 视觉交互
- **默认**

选中条件后`回车`发送指令到插件，数据需要实现插件方法。


![basic.gif](./image/basic.gif)

- **自动补全**

需要写插件实现数据回传，数据返回后可键盘方向键上下选择数据。

![basic.gif](./image/autocompletion.gif)


## 属性说明

属性名 | 属性ID | 类型 | 说明
------ | :----: | :----: | ------
为空提示 | `emptytip` | String | 搜索条件为空时提示信息
搜索风格 | `showModel` | Number | 切换搜索框交互方式，包括`默认` 、 `自动补全`、`自动收起`、`全局搜索` 四种风格，均需要插件实现方法组织数据
搜索字段 | `searchitems` | Array | 设置搜索条件

## 后端API

方法名 | 参数| 返回值 | 说明  
------- | ------- | ------- | ---- 
`getSearchKey` | 无| `String` 搜索关键字 | 获取搜索关键字  
`setSearchKey` | `String` 关键字|无 | 设置搜索关键字  

## 插件范例

- **实现SearchEnterListener接口**

```java
// 实现[SearchEnterListener]接口
public class TestPlugin extends AbstractFormPlugin implements SearchEnterListener {
  public void registerListener(EventObject e) {
  
    // 注册监听
    Serach serach = this.getControl("控件标识");
    search.addEnterListener(this);
  }
  
  public void search(SearchEnterEvent event) {
    // 默认风格 输入搜索条件回车后 进入该方法
  }
  
  public List<String> getSearchList(SearchEnterEvent evt) {
    // 自动补全风格 输入搜索条件后 进入该方法组织数据返回前端显示
  }
}
```