# 矢量图标
>也叫字体图标，可以当做`字体`看待，与一般的图标或图片相比，显示效果更好，放大后不失真。
<u>默认跟随主题色</u>。

## 控件对象
`kd.bos.form.control.Vector`

## 视觉展示

![vector_default.png](./image/vector_default.png) 

- **选择字体图标** 

![vector_selecticon.jpg](./image/vector_selecticon.jpg) 

## 属性说明
属性名 | 属性ID | 类型 | 默认值 | 说明 
---- | :----: | :----: | :----: | ----  
选择图标 | `fontClass` | string | `kdfont kdfont-tianjia` | 选择系统提供的矢量图标
允许点击 | `clickable` | boolean | `true` | 打开后标签允许点击
上传按钮 | `iu` | boolean | `false` | 设置控件是否允许弹出上传文件的窗口，开启后即可设置上传配置属性
上传配置 | `uconfig` | Map |  | 设置上传文件窗口属性（大小、类型、地址、是否多选、临时存储），需`上传按钮`属性开启后才可配置此属性  
操作代码 | `operationKey` | string |  | 配置按钮点击时的框架提供的操作
请求动画 | `controlLoading` | boolean | `true` | 发送请求过程中开启加载动画

?> 控件通用属性[请参考](advanced/controlProperties/)

## 插件API

- **插件动态设置字体图标**

```java
Vector vector = this.getView().getControl("控件标识");
vector.setFontclass("字体图标样式名");
```  

- **矢量图标控件的编程模型是Vector类，派生自按钮控件的编程模型Button：**

```java
package kd.bos.form.control;
public class Vector extends Button {	
```

- **插件可以通过如下代码，获取到界面上超链接控件的编程模型实例：**

```java
Vector vectorIcon = this.getView().getControl(KEY_VECTOR1);
```
