# 视频控件
>用于在单据页面播放视频文件。

## 控件对象
`kd.bos.ext.form.control.Video`

## 视觉展示

- **默认外观** `(注: 该播放器基于web原生实现,在不同浏览器下外观可能略不同)`

![default.png](./image/video_control_no_source.png) 

- **加载(视频)文件播放** 

![playing.png](./image/video_control_playing.png) 


## 控件属性说明

属性名 | 属性ID | 类型 | 说明 
---- | :----: | :----: | ---- 
文件路径 | `src` | string | 视频文件路径 (相对/绝对路径都支持)
自动播放 | `autoPlay` | bool | 属性打开后，控件将设定的文件源自动播放视频

控件通用属性请参考=>[传送门](advanced/controlProperties/)

## 功能说明

功能名 | 说明
------- | ------- 
播放视频 | 根据设定的视频文件地址，播放视频内容(对视频格式有要求，具体请看`支持视频格式`章节)

## 支持视频格式

视频类型 | 视频/音频编码 | 浏览器版本要求
---- | :----: | ----
Ogg(`ogg`) | Theora/Vorbis | 'Firefox 3.5+', 'Opera 10.5+', 'Chrome 5.0+'
MPEG4(`mp4`) | H264/AAC | 'IE 9.0+', 'Chrome 5.0+', 'Safari 3.0+'
WebM(`webm`) | VP8/Vorbis | 'Firefox 4.0+', 'Opera 10.6+', 'Chrome 6.0+'

## 其他说明

pc端/移动端都有视频播放控件

## 插件示例

- **插件代码**
 
```java
public void do() {
    // 设置视频数据源
    Video videoCtl = this.getView().getControl("控件id");
    videoCtl.setSrc("https://www.kingdee.com/kingdee/video/kindee1.mp4");

    // 设置自动播放
    Map<String, Object> dataMap = new HashMap<>();
    dataMap.put("autoPlay", true); //设置为自动播放
    dataMap.put("k", "控件id");
    IClientViewProxy proxy = this.getView().getService(IClientViewProxy.class);
    proxy.addAction(ClientActions.updateControlStates, dataMap);
}
```
