# 附件字段
>简洁版的附件面板，可在卡片分录与单据体中使用；也适用于空间较小的场景，例如侧边栏。

?> 结合 **字段布局面板** 控件使用是最佳实践。

## 控件对象
`kd.bos.form.field.AttachmentEdit`

## 视觉展示
![attachfield.png](./image/attachfield.png)

## 属性说明
### 字段通用属性
?> 字段通用属性[请参考](ctrl/commonField/text/)

### 业务属性
属性名 | 属性ID | 类型 | 默认值 | 说明 
---- | :----: | :----: | :----: | ----
扩展名 | `ext` | string | | 配置可上传文件扩展名，例：`zip,rar`  
显示标题 | `sti` | boolean | `false` | 显示标题的同时显示已经上传的文件数量
最大附件大小 | `maxatmsize` | number | `20` | 设置单个可上传文件大小，在系统参数中可设置服务器最大附件的大小，优先级比设计器属性要高
最大附件数 | `maxatmcount` | number | | 设置附件可上传的文件数量，超出限制则不可上传

### 样式属性
?> 样式属性[请参考](ctrl/commonField/text/)

?> 控件通用属性[请参考](advanced/controlProperties/)

## 功能说明
?> 功能说明[请参考](ctrl/commonControl/attachment/)

## 插件示例
- **设置附件字段值插件事件**

```java
public void afterCreateNewData(EventObject e){
	Object[] attachmentIds  = new Object[1];
	attachmentIds[0] = 607079090620535808L;//fbasedataid
	this.getModel().setValue("attachmentfield", attachmentIds);
}
```

?> 其余插件示例[请参考](ctrl/commonField/text/)