# 大文本字段
>可以在输入框直接输入内容，也可以点击按钮弹出对话框，输入大量内容。

?> 结合 **字段布局面板** 控件使用是最佳实践。

## 控件对象
`kd.bos.form.field.LargeTextEdit`

## 属性说明
### 字段通用属性
?> 字段通用属性[请参考](ctrl/commonField/text/)

### 业务属性
业务属性 | 属性ID | 类型 | 默认值 | 说明 
:---: | :---: | :---: | :---: | --- 
按钮图标 | `fontClass` | string | | 设置大文本的按钮点击图标
编辑模式 | `editingMode` | string | `summary` | 编辑模式可选摘要模式和多行文本模式，多行文本模式没有按钮图标和最大长度限制
为空提示信息 | `emptytip` | Map | | 当字段内容为空时，输入框内显示的信息
锁定为空提示信息 | `lockedemptytip` | Map | | 当字段锁定且内容为空时，输入框内显示的信息

### 样式属性
?> 样式属性[请参考](ctrl/commonField/text/)

?> 控件通用属性[请参考](advanced/controlProperties/)


## 插件示例
- **设置输入框显示摘要，弹出框显示内容详情**

```java
public void propertyChanged(PropertyChangedArgs e) {
		super.propertyChanged(e);
		IDataEntityProperty obj = e.getProperty();
		if (obj != null && "config_tag".equals(obj.getName())){
			ChangeData[] changeSet = e.getChangeSet();
			String newValue = (String) changeSet[0].getNewValue(); 
			if (StringUtils.isNotBlank(newValue)){
				if (newValue.length() > LENGTH)
					newValue = newValue.substring(0, 100);
				LargeTextEdit largeTextEdit = this.getView().getControl("config");
				String field = largeTextEdit.getFieldKey();
				this.getModel().setValue(field, newValue);
			}
		}
	}
```  

?> 其余插件示例[请参考](ctrl/commonField/text/)
