# 多选下拉列表字段
>下拉选择内容的组件，多选。

?> 结合 **字段布局面板** 控件使用是最佳实践。

## 控件对象
`kd.bos.form.field.MulComboEdit`

## 视觉展示
![combo.png](./image/mulcombo.png ':size=300x200')

## 属性说明
### 字段通用属性
?> 字段通用属性[请参考](ctrl/commonField/text/)

### 业务属性
业务属性 | 属性ID | 类型 | 默认值  | 说明  
:----: | :----: | :----: |  ---- | ---- 
显示样式 | `showStyle` | number | `0` | 设置下拉项显示内容：文字（`0`）、图片（`1`）、文字+图片（`2`）
下拉风格 | `showtype` | number | `0` | 设置下拉风格：默认风格(`0`)、风格一（`1`），`风格一`为下拉图标跟随选中内容长度改变位置
下拉项 | `st` | Array | | 设置下拉字段下拉项信息，可配置标题，内容和图片
为空提示信息 | `emptytip` | Map | | 当字段内容为空时，输入框内显示的信息
已选项风格 | `sis` | string | `text` | 分为文本风格(`text`)和标签风格(`label`),选择标签风格时下拉项以标签形式展示
校验下拉值 | | boolean | `false` | 给下拉列表赋值时，校验此值是否在下拉列表中存在

### 样式属性
?> 样式属性[请参考](ctrl/commonField/text/)

?> 控件通用属性[请参考](advanced/controlProperties/)

### 即时触发值更新
?> 即时触发值更新[请参考](ctrl/commonField/text/)

## 插件示例
- **动态修改下拉项**

```java
MulComboEdit mulComboEdit = this.getControl("mulcomboedit");
		List<ComboItem> data2 = new ArrayList<>();
		data.add(new ComboItem(new LocaleString("第一项"), "a"));
		data.add(new ComboItem(new LocaleString("第二项"), "b"));
		mulComboEdit.setComboItems(data2);
```  

?> 其余插件示例[请参考](ctrl/commonField/text/)