# 步进器字段
>当想要对数值进行小幅度调整时，可以使用，用作增加或者减少当前数值。

?> 结合 **字段布局面板** 控件使用是最佳实践。

## 控件对象
`kd.bos.form.field.StepperEdit`

## 视觉展示
风格 |视觉   
------- | -------  
默认 | ![stepper_default.png](./image/stepper_default.png) 
迷你 | ![stepper_mini.png](./image/stepper_mini.png) 
基础 | ![stepper_box.png](./image/stepper_box.png) 

## 属性说明
### 字段通用属性
?> 字段通用属性[请参考](ctrl/commonField/text/)

### 业务属性
属性名 | 属性ID | 类型 | 默认值 | 说明 
---- | :----: | :----: | :----: | ---- 
显示风格 | `stepperstyle` | number | `0` | 设置步进器字段的显示风格，有默认（`0`）、迷你（`1`）、基础（`2`）三种风格
数值类型 | `nt` | string | `整数` | 设置步进器字段的数值类型，有`小数`与`整数`两种类型
步进值 | `stepvalue` | number | `1` | 设置步进器字段每次改变的步数大小
不显示尾零 | `sz` | boolean | `false` | 勾选之后，如果数值类型为小数，那么小数点后存在尾零，则编辑完成后不显示
掩码 | `mask` | string |  | 设置数值编辑完成之后的显示，控制数值的显示格式，包括分隔符和百分号的控制
格式化字符串 | `df` | string |  | 设置数值编辑完成之后的显示，控制数值的显示格式，包括分隔符和百分号的控制
缺省值 |  | number | `0` | 缺省值默认是0 如果使用过程中没有输入相应的值
小数精度 | `sc` | number | `10` | 如果数值类型为小数，设置小数部分的精度
数值范围 |  | string |  | 设置数据可输入范围，例：`[0,99]`  `(0,99)`

### 样式属性
?> 样式属性[请参考](ctrl/commonField/text/)

?> 控件通用属性[请参考](advanced/controlProperties/)

### 即时触发值更新
?> 即时触发值更新[请参考](ctrl/commonField/text/)