# 分割容器
>界面需要分为两个部分，且两个部分显示内容有主次之分时使用。

## 控件对象
`kd.bos.form.control.SplitContainer`

## 视觉
- 两个分割容器嵌套

![风格](./image/style.png)

## 属性说明
属性名 | 属性ID | 类型 | 默认值 | 说明 
:----: | :----: | :----: | :----: | :----  
分割位置 | `splitPosition` | String | | 根据分割方向，设置分割容器上方容器高度、或者是左边容器宽度
分割方向 | `splitStyle` | String | | 设置分割容器的分割方向
子容器最小宽度 | `minWidth` | number | | 设置子容器最小宽度，`分割位置`是百分比分割也受这个最小值限制，可设置值范围`[5-容器可用宽度]`，分割方向为`纵向`才生效
子容器最小高度 | `minHeight` | number | | 设置子容器最小高度，`分割位置`是百分比分割也受这个最小值限制，可设置值范围`[5-容器可用高度]`，分割方向为`横向`才生效

?> 控件通用属性[请参考](advanced/controlProperties/)

## 插件API

方法名 | 参数 | 说明  
------- | ------- | -------  
`changeFlexStatus` | `SplitDirection, status` 方向，是否折叠 | 动态设置分割容器面板折叠，`true`折叠，`false`展开   
`setSubContainerMinWidth`|`int`最小宽度值，单位是`px`|设置子容器最小宽度值，单位`px`，分割方向为`纵向`才生效
`setSubContainerMinHeight`|`int`最小高度值，单位是`px`|设置子容器最小高度值，单位`px`，分割方向为`横向`才生效

## 插件示例

- **控制左面板折叠**

```java
// 插件控制左面板折叠
SplitContainer splitc = this.getControl("控件标识");
splitc.changeFlexStatus(SplitDirection.left, true);
// 设置子分割容器面板最小宽度
splitc.setSubContainerMinWidth(300);
// 设置子分割容器面板最小高度
splitc.setSubContainerMinHeight(300);
```  
