# 列表
>以表格列表形式展示单据的数据。很多属性和单据上是一样的，这里只介绍列表中特有的属性。
此处分为两种形式
- 列表设计器，列表的映射实体是确定的，就是当前的单据实体，不需要配置单据实体和字段映射关系。
- 单据列表控件，表单中使用列表，需要配置单据实体和字段映射关系。


## 视觉展示

- **设计时视图**

![liebiaoshejiqi.jpg](./image/liebiaoshejiqi.jpg)

- **运行时视图**

![danjuliebiaozhanshi.jpg](./image/danjuliebiaozhanshi.png)

## 表格属性

属性名 | 属性ID | 类型  | 默认值  | 说明  
------- | :-------: | :-------:   | :-------: | -------  
折叠显示 | `DetailEntry` | boolean | `false`| 是否启用行展开功能，默认展开单据中分录数据
折叠显示高 |`FormDetailHeight`|number|`200`| 设置折叠容器显示高度，需打开折叠显示
折叠表单 |`FormDetailId`|string|--|行展开显示成关联的表单，需打开折叠显示
行高自适应 |`AutoRowHeight`|boolean|--|行高根据内容自适应。[详细说明](ctrl/grid/billlist/?id=行高自适应)

### 折叠显示

折叠显示默认折叠的是该条单据下的单据体，也可以通过设置`折叠表单`来修改成要展示的页面。

![ 折叠显示](./image/rowDetail.png)


### 行高自适应
表格级属性，多行多语言字段、多行文本支持较好，文本、大文本、基础资料和多语言文本可以换行，其他字段如金额、数字等由于规范不会换行。
设置行高自适应后，合计行的高度会取默认的设置的行高。

![ 行高自适应](./image/autoRowHeight.gif)

?> `行融合`下该属性不会生效

### 列属性
参考`单据体`


### 列宽自适应
列表默认有列宽自适应功能，当列表有剩余宽度时，会平均分配到所有未设置列宽的列上。

?> 注意只有默认列宽的列才会自适应，其他如设置了列宽、拖动过列宽的列不会自适应。

### 用户个性化数据

 - **列宽**: 用户拖拽过的列宽，关闭表单，该数据会存储在服务端，下次再打开该列表将是拖拽过的列宽。
 - **每页显示条数**：用户修改每页显示条数，关闭表单，该数据会存储在服务端，下次再打开该列表会每页将以上次关闭的每页条数显示。

### 表格设置

列表右上角齿轮按钮打开，用户级别的个性化设置。

- **只显示单据头 （只会显示单据头字段）**
- **设置列对齐方式 （居中、居右还是居左）**
- **设置冻结列 （设置后该列会固定在左侧）**
- **设置隐藏列 (该列将会被隐藏)**
- **上移、下移 （改变列的显示顺序）**

![列表控制](./image/liebiaokongzhi.png)

## 控件方法
列表后端提供控件方法去修改相关属性，此处展示后端调用对应控件方法后，返回到前端的指令和参数介绍。

!> 1.后端调用控件方法请参考后端文档，前端的方法名跟后端控件调用的方法名是一致的。<br/>
 2.注意参数传递有差异，领域模型返回的控件方法参数（args）是包装了一层数组的。

![controlMethods](../img/controlMethods.png)

方法名 | 参数格式 | 说明 
:-------: | ------- | ------- 
 `selectRows` | [[行号]]|表格设置的选中行 |
 `setFocus` | [[行号]]|设置的焦点行 |
`visible` |[{"v":[{"vi":"是否可见true/false","k":"字段名"}],"o":"expenseamount"}]]}]} |  动态设置表格列可见性 
 `setCellStyle` |[[{r:行号,c:'字段名',s:{'样式名':'样式属性'}}]]|设置单元格样式 |
`setColProp`|['字段名',属性,属性值]|动态设置单据体特定列的某属性(比如可以修改标题'Header'、可见性和锁定性等)|
`setColEditorProp`|['字段名','属性名',属性值]}]|动态设置单据体特定列的Editor中的某属性(比如必录项'mi') |
`hideOperateItems`|['字段名','属性名',属性值]|动态设置隐藏操作列的操作项|
`lockOperateItems`|[{"colId": "字段名","opks": ["操作id"],"rowKey": 行号}]|动态设置锁定操作列的操作项
`expandOrCloseRowDetail`|[展开行号数组, 关闭行号数组, 是否关闭其他全部]|展开或者关闭展开行

  <!-- `setRowStyle` | [[{"r":[行号],"s":{"样式名":"样式属性"}}]]|设置行的样式（可以设置多行）| -->
## 单据列表控件
单据列表可以在表单中使用列表，需要配置单据实体和配置字段映射关系,操作如下

![peizhidanjuliebiao.gif](./image/peizhidanjuliebiao.gif) 


 
