# 表格公共属性
>该部分介绍表格（包括列表、报表和单据体）的公共属性和功能

## 列宽
列有默认宽度，下面列出不同类型字段默认的列宽。

宽度(px) | 字段类型 |
:-------: | -------
`60` | 附件
`100` | 复选框 
`100` | 基础资料、下拉列表、图片 
`123` | 手机号
`148` | 日期、长日期、时间、时间范围、数字
`200`| 多选下拉列表、文本、大文本、多语言文本、多行文本

### 列宽优先级
用户有拖动的列宽（个性化数据列宽） > 设计器和元数据设置的列宽 > 默认的列宽

### 列宽自适应
当所有列宽的和小于容器的宽度时，所有未设置列宽的列（*）会自动按比例自动增加列宽。

> 1.列表和报表有列宽自适应功能，单据体没有。<br/>
> 2.序号列、选择列、日期、长日期、日期范围、下拉列表、用户类型列的列宽不会扩展<br/>
> 3.*用户未拖动过且未设置列宽的列

### 列宽记忆功能
用户关闭表单后，系统会记录下关闭前最终状态的表格列宽信息，当下次该用户再次进入该表单时，会保持上次的表格列宽。

> 列宽有变化时（如用户拖动过、列宽自适应扩展了宽度），关闭表单都会被记录。

## 列对齐
后端未设置列对齐方式时，大部分列均为左对齐，特例如下。

对齐方式 | 字段类型 |
:-------: | -------
右对齐 | 数字（包括整数、小数、数量、金额）
居中 | 复选框、下拉列表、多选下拉列表、图片

## 锁定性
表格锁定性有：整表锁定性、列锁定和单元格锁定，列锁定性跟列元数据中的`l`属性有关（该属性根据表单状态决定是否锁定）。
`列表`和`报表`默认整表锁定，无法解锁。

!> 三个锁定性只要有一个锁定目标单元格就会锁定，解锁需要所有的锁定性都为不锁定，比如你使用了单元格锁定方法锁定了单元格，使用行锁定方法不能解除单元格锁定方法，必须得使用锁定对应的方法去解锁。

锁定和解锁的控件方法（[控件方法](ctrl/grid/entry/?id=控件方法)）：
- 行锁定：rowLock （仅整行锁定）
- 单元格锁定：lock (可实现列锁定、行锁定和单元格锁定)
- 操作列的操作项的锁定性比较特殊，可以通过`lockOperateItems`去锁定，但是不支持解锁，目前可以通过设置值修改操作项锁定性（[操作列值](ctrl/grid/column/?id=操作列值格式)）。

## 可见性
表格可见性：整表可见性、列可见性（注意没有单元格可见性和行可见性），列可见性跟列元数据中的`vi`属性有关（该属性根据表单状态决定是否隐藏）。
分组列不可见，子列也会被隐藏。

!> 只要有一种可见性设置为不可见，目标单元格就会隐藏，和锁定性一样，隐藏了的列要再次显示，需要所有的可见性都为可见才会取消隐藏。

隐藏和显示的[控件方法](ctrl/grid/entry/?id=控件方法)：
- 列隐藏/显示：visible
- 操作列的操作项的可见性比较特殊，可以通过`hideOperateItems`去隐藏，但是不支持显示，目前可以通过设置值修改操作项的可见和隐藏（[操作列值](ctrl/grid/column/?id=操作列值格式)）。

## 样式（行/列/单元格）
行/列/单元格样式的展示最终都为单元格样式改变，修改样式的[控件方法](ctrl/grid/entry/?id=控件方法)
- 修改行样式（不支持列表）：setRowStyle 
- 修单元格样式：setCellStyle 
- 修改列样式：可以通过修改列属性去修改，也可以通过修改单元格样式去修改。

## 列属性修改
表格列属性修改通过修改列的元数据实现，可以使用[控件方法](ctrl/grid/entry/?id=控件方法) **setColProp** 修改`过滤`、`排序`、`可见性`、`锁定性`、`列头名称`、`列对齐方式`、`宽度`、`单据体列样式`。


## 列editor属性修改
表格有些属性跟编辑有关，修改这些属性需要通过修改列的元数据editor实现，可以使用[控件方法](ctrl/grid/entry/?id=控件方法) **setColEditorProp** 修改`必录`、`最大最小值`、`精度信息`、`列表列样式`。


## 右键菜单
表格内容区，鼠标右键点击唤起右键菜单。

- 右键菜单视觉

![右键菜单](./image/contextMenu.png) 

- *区域选中（选中多个单元格）视觉

![区域选中](./image/rangeSelect.png) 

### 复制
复制当前选中的单元格的值，有区域选中（*）时复制选中区域的值，没有时复制右键点击的单元格值。

### 清空过滤条件
清空列头所有过滤条件。

### 列宽自适应
当前选中的列宽度自适应内容的宽度，有区域选中（*）时区域选中的列都会自适应列宽，没有时仅右键点击的列自适应列宽。

> 序号列、选择列不会适应内容宽度。

### 全部列宽自适应
所有列宽度自适应内容的宽度

> 序号列、选择列不会适应内容宽度。

### 重置列
清空列头所有过滤条件，刷新列头提示，重新设置列元数据。