# 单据体
>展示一批具有相同属性的数据，类似Excel。在业务语义上一个单据体对应数据库中一张表，其中一列对应数据库表的一列。
<u>单据体可编辑录入数据。</u>

## 控件对象
`kd.bos.form.control.EntryGrid`

## 视觉展示

- **单据体视图**
![运行时](./image/danjutiyunxingshi.png)

- **平铺视图**
![pignpushitu.png](./image/pignpushitu.png)



## 表格属性
复杂属性在属性表格下方有具体说明

属性名 | 属性ID | 类型  | 默认值  | 说明  
------- | :-------: | :-------:   | :-------: | -------  
行高 | `RowHeight`|number |`40`| 设置表格每行的高度
表头高度 | `HeadHeight` | number |`34`| 设置表头的高度  
显示序号列 | `ShowSeq` | boolean |`false` |设置序号列是否显示
显示选择列 |`ShowSelChexkbox`|boolean|`false` |设置选择列是否显示
行内增删 |`HasOperateIcon`|boolean|`false` |设置行上增删功能,需要打开`显示选择列`开关 [详细说明](ctrl/grid/entry/?id=行内增删)
可折叠 | `collapsible` | boolean |`false` | 设置控件是否可折叠，可折叠情况下可设置`默认折叠`
显示Tips|`CtlTips`|--| -- |`可折叠`属性开启的情况下有该属性，为面板配置tips信息
多选|`Multi`|boolean|`false`|  设置是否可选择多行 
排序和过滤 | `OrderAndFilter`| boolean|`true` | 设置是否允许列头开启排序过滤功能   
分页 |`SplitPage`|boolean|`false`|   是否分页展示数据，开启后出现分页工具栏 
分页条数 |`PageRow`|number|`20`|   单据体每页显示多少条记录
界面规则 |`Rules`| -- |--|  设置列规则来达到预置的条件时触发界面改变 [详细说明](ctrl/grid/entry/?id=界面规则)
显示平铺视图 |`ShowFlatPanel`| boolean |`false`|  单据体平铺视图展示 [详细说明](ctrl/grid/entry/?id=平铺视图)
显示表格设置 |`ShowGridConfig`| boolean| `true` | 表格右上角显示设置图标，可对表格进行配置
表名|`TableName`|string|--|    设置数据库表名，**动态表单没有该属性**
缺省行数 |`DefaultRows`| number |`1`| 设置默认有几个空行  
关键字段 |`KeyFieldId`| -- |-- | 配置分录的关键字段,用于表明分录行录入的有效性
行高自适应 |`AutoRowHeight`|boolean|--|行高根据内容自适应。[详细说明](ctrl/grid/billlist/?id=行高自适应)
勾选模式 |`SelectType`| string |  | 默认为空，勾选框选中模式为`checkboxSelect`，只能通过勾选框来进行选中/反选操作; 列表选中模式为 `listSelect`,单据体会自动锁定，可以点击整行来进行选中/反选操作

### 界面规则
可设置一系列规则来达到预置的条件时触发某种动作，常用的场景有：`隐藏`、`显示`、`锁定`、`解锁`列。

- **举个例子，锁定所有18岁的人员`姓名`列，不是18岁的人员不锁定**

1.建立一个`18岁`规则条件。  
2.建立一个条件`成立`时的动作。  
3.建立一个条件`不成立`时的动作。  

![界面规则](./image/fuwuduanjiemianguize.gif)

### 平铺视图

将单据体的值录入形式改成单据头录入形式  

![pignpushitu.png](./image/pignpushitu.png)
####  操作步骤
![pingpushitubuzhou.gif](./image/pingpushitubuzhou.gif)

####  相关属性

- **平铺视图摘要**

可以选择平铺视图左侧要显示的辅助文字

![pingpushituzhaiyao.gif](./image/pingpushituzhaiyao.gif)

- **多字段面板**

平铺容器支持多个字段面板,支持多字段面板展示

![c11e6102cda42ca9.png](./image/pingpushituduomianban.png)

### 行内增删

鼠标在行上悬浮时，序号列显示增删按钮，用户可以新增一行或者删除本行。

> 用户可以使用更新元数据的方式，来动态控制是否显示悬浮按钮。方法名为`updateControlMetadata`，属性Key为`hasOperateIcon`。
 
### 列属性
属性名 | 属性ID | 类型  |  说明  
------- | ------- | -------   | -------   
显示Tips|`CtlTips`|--|配置列头tips
超链接(不可编辑列) | `Hyperlink`|boolean| 设置该列显示为超链接形式，展示数据时才生效 
汇总方式 |`Summary` | -- | 数字列才有该属性，显示这一列汇总信息

?> 字段的通用属性不展示,可以参考相关字段文档


## 控件方法
单据体后端提供控件方法去修改相关属性，此处展示后端调用对应控件方法后，返回到前端的指令和参数介绍。

!> 1.后端调用控件方法请参考后端文档，前端的方法名跟后端控件调用的方法名是一致的。<br/>
 2.注意参数传递有差异，领域模型返回的控件方法参数（args）是包装了一层数组的。

![controlMethods](../img/controlMethods.png)

方法名 | 参数格式 | 说明 
:-------: | ------- | ------- 
 `setColFmtInfo` | ['字段名',{格式化信息数据，如pp：2}] |设置列关联的单据头字段 
 `setCurrencyFmtInfo` | '字段名',{格式化信息数据，如pp：2}]|设置列关联单据体字段，取金额-币别信息 
 `setUnitFmtInfo` | '字段名',{格式化信息数据，如ps：2}] | 设置列关联单据体字段，取数量-单位信息 
 `appendRows` | [[[行数据]]] |表格行末新增行 
`deleteRows`|[[行号]]|表格删除选中行 |
 `insertRow` | [[行号]]|表格插入新行 |
 `moveUp` | [[行号]]|表格选中行上移一行 |
 `moveDown` | [[行号]]|表格选中行下移一行 |
 `selectRows` | [[行号]]|表格设置的选中行 |
 `setFocus` | [[行号]]|设置的焦点行 |
`lock` |[{"v":[{"vi":"是否可见true/false","k":"字段名"}]}]| 动态设置grid列/单元格/行的锁定 
`visible` |[{"v":[{"vi":"是否可见true/false","k":"字段名"}],"o":"expenseamount"}]]}]} |  动态设置表格列可见性  `rowLock` |[{"r":[行号],"o":"s",l:是否锁定}]}]| 动态设置整行的锁定 
  `setRowStyle` | [[{"r":[行号],"s":{"样式名":"样式属性"}}]]|设置行的样式（可以设置多行）|
 `setCellStyle` |[[{r:行号,c:'字段名',s:{'样式名':'样式属性'}}]]|设置单元格样式 |
 `expandAllNode` | [[]]|展开树形单据体行的所有节点 |
`collapseAllNode` | [[]]|关闭树形单据体行的所有节点 | 
 `expandNode` | [[行号]]|展开树形单据体行的子节点 |
`collapseNode` | [[行号]]|关闭树形单据体行的子节点 | 
 `cellStartEdit` | [{ "r": 行号, "k":'字段名'}]|设置某个单元格进入编辑(单据体) |
`setColProp`|['字段名',属性,属性值]|动态设置单据体特定列的某属性(比如可以修改标题'Header'、可见性和锁定性等)|
`setColEditorProp`|['字段名','属性名',属性值]}]|动态设置单据体特定列的Editor中的某属性(比如必录项'mi') |
`hideOperateItems`|['字段名','属性名',属性值]|动态设置隐藏操作列的操作项|
`lockOperateItems`|[{"colId": "字段名","opks": ["操作id"],"rowKey": 行号}]|动态设置锁定操作列的操作项|


## 插件示例
- **创建行**

```java
// 创建一行，返回行号
int rowIndex = this.getModel().createNewEntryRow("单据体标识" );

// 根据数据创建多行，返回行号数组
int count = 5; // 数据行数
int[] rowIndex = this.getModel().batchCreateNewEntryRow("单据体标识", count);

// 根据创建的行，设置内容
for (int i = 0; i < count; i++) {
  this.getModel().setValue("字段标识", 内容, rowIndex[i]);
}
```  

- **删除行**

```java
this.getModel().deleteEntryRow("单据体标识", 行号);

this.getModel().deleteEntryRows("单据体标识", 行号数组);
```  
- **值操作**

```java
this.getModel().getValue("字段标识", 行号);
this.getModel().setValue("字段标识", 内容, 行号);

```  

- **隐藏/锁定 某个单元格**

```java
EntryGrid entry = this.getView().getControl("标识");
// 隐藏
entry.setChildVisible(false, 行号, 控件标识);

// 显示
entry.setChildVisible(true, 行号, 控件标识);

// 锁定
this.getView().setEnable(false, 行号，控件标识);

// 解锁
this.getView().setEnable(true, 行号，控件标识);
```  

- **插件动态添加一列**

```java
/**
* 
* 案例说明
* 1. 在界面加载时，向界面添加字段与控件：
* a. 向单据头添加一个新的文本字段autotext1，字段值由插件填写；
* b. 向单据体添加一个新的文本字段autotext2，字段值由插件填写；
* c. 添加一个新的按钮 autobutton1；
* 2. 用户点击动态添加的按钮时，显示提示信息
* 
* 实现方案
* 1. 打开设计器，在界面上增加一个容器面板(myfieldcontainer)，用来包含本插件代码动态添加的字段、控件
* 2. 捕获 loadCustomControlMetas 事件，向容器控件添加新的字段、控件
* 3. 捕获 getEntityType 事件，向主实体，注册添加的文本属性
* 4. 捕获 createNewData 事件，自行构建界面数据包
* 5. 捕获 beforeBindData 事件，输出自定义字段值到前端界面
* 6. 捕获 onGetControl 事件，输出动态添加的字段、按钮的控件编程模型
* 
*/
public class LoadCustomControlMetasSample extends AbstractFormPlugin implements ClickListener {

  private final static String KEY_ENTRYENTITY = "entryentity";
  private final static String KEY_MYFIELDCONTAINER = "myfieldcontainer";
  private final static String KEY_AUTOTEXT1 = "autotext1";
  private final static String KEY_AUTOTEXT2 = "autotext2";
  private final static String KEY_AUTOBUTTON1 = "autobutton1";

  /**
  * 界面显示前，触发此事件：向前端界面输出动态添加的字段、控件
  * @remark
  * 这个事件只能向前端界面添加字段、控件；后台的视图模型、数据模型，均没有改变
  */
  @Override
  public void loadCustomControlMetas(LoadCustomControlMetasArgs e) {
    super.loadCustomControlMetas(e);

    // 动态添加单据头字段、按钮
    FlexPanelAp headAp = this.createDynamicPanel();
    Map<String, Object> mapHead = new HashMap<>();
    mapHead.put(ClientProperties.Id, KEY_MYFIELDCONTAINER);
    mapHead.put(ClientProperties.Items, headAp.createControl().get(ClientProperties.Items));
    e.getItems().add(mapHead);

    // 动态添加单据体字段
    EntryAp entryAp = this.createDynamicEntryAp();
    Map<String, Object> mapEntry = new HashMap<>();
    mapEntry.put(ClientProperties.Id, KEY_ENTRYENTITY);
    mapEntry.put(ClientProperties.Columns, entryAp.createControl().get(ClientProperties.Columns));
    e.getItems().add(mapEntry);
  }

  /**
  * 此事件在系统要用到表单主实体模型时触发
  * @param e
  * @remark
  * 插件修改原始主实体，注册自定义属性，返回新的主实体给系统
  */
  @Override
  public void getEntityType(GetEntityTypeEventArgs e) {

    // 取原始的主实体
    MainEntityType oldMainType = e.getOriginalEntityType();
    // 复制主实体
    MainEntityType newMainType = null;
    try{
      newMainType = (MainEntityType)oldMainType.clone();
    } catch (CloneNotSupportedException exp){
      throw new KDException(exp, new ErrorCode("LoadCustomControlMetasSample", exp.getMessage()));
    }

    // 为自定义的文本字段，向主实体注册文本属性
    this.registDynamicProps(newMainType);

    // 回传主实体给系统
    e.setNewEntityType(newMainType);
  }

  /**
  * 此事件在表单创建界面数据包时触发
  * @remark
  * 由插件自行创建界面数据包，包含自定义字段
  */
  @Override
  public void createNewData(BizDataEventArgs e) {

    DynamicObject dataEntity = new DynamicObject(this.getModel().getDataEntityType());
    dataEntity.set(KEY_AUTOTEXT1, "动态文本字段1的值");

    DynamicObjectCollection rows = dataEntity.getDynamicObjectCollection(KEY_ENTRYENTITY);
    DynamicObject newRow = new DynamicObject(rows.getDynamicObjectType());
    newRow.set(KEY_AUTOTEXT2, "动态文本字段2的值");

    rows.add(newRow);

    e.setDataEntity(dataEntity);
  }

  /**
  * 此事件在把数据绑定到界面之前触发：
  * 系统会调用FormDataBinder对象，把字段值输出给前端字段编辑控件；
  * @param e
  * @remark
  * 动态添加的字段，在FormDataBinder中并没有记录，因此，默认不会绑定动态添加的字段值；
  * 必须在此事件，向FormDataBinder中注册动态添加的字段
  */
  @Override
  public void beforeBindData(EventObject e) {

    // 单据头添加的字段、控件，注入到容器面板的控件编程模型中
    FlexPanelAp dynamicPanel = this.createDynamicPanel();
    Container myFldPanel = this.getView().getControl(KEY_MYFIELDCONTAINER);
    myFldPanel.getItems().addAll(dynamicPanel.buildRuntimeControl().getItems());
    this.getView().createControlIndex(myFldPanel.getItems());

    // 单据体添加的字段，注入到单据体表格的控件编程模型中
    EntryAp dynamicEntryAp = this.createDynamicEntryAp();
    EntryGrid entryGrid = this.getView().getControl(KEY_ENTRYENTITY);
    List<Control> fieldEdits = dynamicEntryAp.buildRuntimeControl().getItems();
    for(Control fieldEdit : fieldEdits){
      fieldEdit.setView(this.getView());
      entryGrid.getItems().add(fieldEdit);
    }
  }

  /**
  * 用户与自定义的控件进行交互时，会触发此事件
  * @remark
  * 插件在此事件中，创建自定义控件的编程模型，并侦听其事件
  */
  @Override
  public void onGetControl(OnGetControlArgs e) {
    if (StringUtils.equals(KEY_AUTOBUTTON1, e.getKey())){
      // 用户点击按钮时，会触发此事件：创建按钮的控件编程模型Button实例返回

      Button button = new Button();
      button.setKey(KEY_AUTOBUTTON1);	// 必须
      button.setView(this.getView()); // 必须

      button.addClickListener(this);
      e.setControl(button);
    } else if (StringUtils.equals(KEY_AUTOTEXT1, e.getKey())){
      // 用户修改了文本1字段值，前端上传字段值时，会先取字段的控件编程模型；
      // 如果没有本段代码，字段值上传失败，不会修改到数据模型中
      TextEdit textEdit = new TextEdit();
      textEdit.setKey(KEY_AUTOTEXT1);
      textEdit.setView(this.getView());
      e.setControl(textEdit);
    } else if (StringUtils.equals(KEY_AUTOTEXT2, e.getKey())){
      TextEdit textEdit = new TextEdit();
      textEdit.setKey(KEY_AUTOTEXT2);
      textEdit.setEntryKey(KEY_ENTRYENTITY);
      textEdit.setView(this.getView());
      e.setControl(textEdit);
    }
  }

  @Override
  public void click(EventObject evt) {
    super.click(evt);
    Control source = (Control)evt.getSource();
    if (StringUtils.equals(source.getKey(), KEY_AUTOBUTTON1)){
      String text1 = (String)this.getModel().getValue(KEY_AUTOTEXT1);
      this.getView().showMessage("您点击了动态添加的按钮1，此时动态文本字段1的值是：" + text1);
    }
  }

  /**
  * 创建一个面板，并向其中动态添加字段、控件
  */
  private FlexPanelAp createDynamicPanel(){

    FlexPanelAp headPanelAp = new FlexPanelAp();
    headPanelAp.setKey("headAp");

    // 动态添加一个文本字段
    FieldAp fieldAp = new FieldAp();
    fieldAp.setId(KEY_AUTOTEXT1);
    fieldAp.setKey(KEY_AUTOTEXT1);
    fieldAp.setName(new LocaleString("自动文本1"));
    fieldAp.setBackColor("#FFFFFF");
    fieldAp.setFireUpdEvt(true);	// 即时触发值更新事件

    TextField field = new TextField();
    field.setId(KEY_AUTOTEXT1);
    field.setKey(KEY_AUTOTEXT1);
    fieldAp.setField(field);

    headPanelAp.getItems().add(fieldAp);

    // 动态添加一个按钮
    ButtonAp buttonAp = new ButtonAp();
    buttonAp.setId(KEY_AUTOBUTTON1);
    buttonAp.setKey(KEY_AUTOBUTTON1);
    buttonAp.setName(new LocaleString("自动添加的按钮"));

    headPanelAp.getItems().add(buttonAp);

    return headPanelAp;
  }

  /**
  * 创建一个单据体表格，并向其中动态添加字段
  */
  private EntryAp createDynamicEntryAp(){

    EntryAp entryAp = new EntryAp();
    entryAp.setKey("entryap");

    // 动态添加一个文本字段
    EntryFieldAp fieldAp = new EntryFieldAp();
    fieldAp.setId(KEY_AUTOTEXT2);
    fieldAp.setKey(KEY_AUTOTEXT2);
    fieldAp.setName(new LocaleString("自动文本2"));
    fieldAp.setFireUpdEvt(true);	// 即时触发值更新事件

    TextField field = new TextField();
    field.setId(KEY_AUTOTEXT2);
    field.setKey(KEY_AUTOTEXT2);
    fieldAp.setField(field);

    entryAp.getItems().add(fieldAp);

    return entryAp;
  }
}

```  


### 事件监听

监听接口 | 方法 | 说明  
------- | ------- | -------  
`CellClickListener` | `cellClick` | 单元格单击事件  
 |`cellDoubleClick` | 单元格双击事件  
`EntryGridBindDataListener` |`entryGridBindData` | 单据体表格绑定数据时间，按分页绑定数据  
`HyperLinkClickListener`|`hyperLinkClick`| 单元格超链接事件
`RowClickEventListener`|`entryRowClick`| 行单击事件
|`entryRowDoubleClick`|行双击事件
`HeaderCellClickListener`|`headerCellClick`|点击列头事件


### 插件API

方法名 | 参数 | 说明  
------- | ------- | -------  
`clearEntryState` | 无 | 清除所有页的行选中状态  
`getDataIndex` | 无 | 获取数据索引  
`getEntryState` | 无 | 获取表格状态对象  
`getFieldEdits` | 无 | 获取所有字段编辑对象
`getRowBindValue`|`BindContext`绑定上下文对象| 获取行绑定值
`getSelectRows`|无|获取选择的行
`getSubEntryGrids`|无|获取自分录表格集合
`getSum`|`String` 合计字段名| 获取合计值
`selectRows`|`int`行号|选中某行
`selectRows`|`int[], int` 行号，聚焦行号|选中多行记录
`selectRows`|`int, boolean`行号，是否强制刷新焦点行|选中多行记录
`setCellBackcolor`|`String, String, int[]` 列标识，颜色，行索引|设置单元格背景色
`setColumnProperty`|`String, String, Object`列标识，属性名，属性值|设置列属性
`setMustInput`|`String, boolean`列标识，是否必录|设置列是否必录
`setRowBackcolor`|`String, int[]`颜色值，行索引数组|设置行背景色
`updateCell`|`String, int`列标识，行号 |刷新单元格
`hideOperateItems`|`String, int, List<String>`列标识，行号，操作标识|设置操作列中子项的可见性
`setNumFmtInfo`|`IDataEntityProperty, DynamicObject`|把币别信息设置到单据体，整列都取相同的币别信息

