# 树形单据体
>树形单据体是单据体的一种特例，会将单据体以父子层级的样式去展示。其中在设计时的属性和单据体是一样的，行数据中包含id和pid，用来决定数据之间的父子关系。未展开的节点展示时异步加载下级数据。

## 视觉展示
![属性单据体](./image/shuxingdanjuti.png)

## 数据配置
1. 前端插入数据构造树形单据体数据，单据需要配置两个操作`新增分录` `插入分录`
2. 或者可以由后端直接构造属性单据体数据

![创建方法](./image/shuxingdanjuti.gif)

## 控件方法
树形单据体提供控件方法去修改相关属性，此处展示前端的控件方法。

这里只列出树形单据体特有的指令，其他方法同`单据体`

指令名 | 参数格式 | 说明 
:-------: | ------- | ------- 
 `expandAllNode` | [[]]|展开树形单据体行的所有节点 |
`collapseAllNode` | [[]]|关闭树形单据体行的所有节点 | 
 `expandNode` | [[行号]]|展开树形单据体行的子节点 |
`collapseNode` | [[行号]]|关闭树形单据体行的子节点 | 

## 插件代码
### 插件API

这里只列出树形单据体特有的API，其他可参考`单据体`

方法名 | 参数 | 说明  
------- | ------- | -------  
`setCollapse` | `boolean` | 展开`true`、折叠`false`  全部行  
`collapse` | `int[]` 一组行号 | 折叠某些行  
`collapseOne` | `int` 行号 | 折叠某行
`expand`|`int[]` 一组行号|展开某些行
`expandOne`|`int`行号| 展开行
`foucs`|`int, int`父行号，行号| 聚焦到某行 
`getExpandNodes`|无|获取展开的节点

?> 其他属性、插件代码规范请参考[单据体](ctrl/grid/entry/)