# 审批记录控件

* 简介

审批记录控件用来展示单据在流程中的审批记录信息。

![审批记录控件](./images/approvalRecord.png)


* 控件对象

`kd.bos.workflow.component.ApprovalRecord`


## 使用说明

审批记录可以添加到单据页面或动态表单中：

### 单据页面

* BOS设计器：

![审批记录控件使用_单据](./images/approvalRecord_bill.png)

* 数据加载

如果是在单据页面中，则会自动根据单据ID加载数据

* 运行效果：

![审批记录控件使用效果_单据](./images/approvalRecord_bill_show.png)

### 动态表单

* BOS设计器：

![审批记录控件使用_动态表单](./images/approvalRecord_form.png)

* 数据加载

如果是在动态表单中，则需要在插件中给控件设置单据ID，样例代码如下:

```java
import java.util.EventObject;

import kd.bos.form.plugin.AbstractFormPlugin;
import kd.bos.workflow.component.ApprovalRecord;

public class TestApprovalRecordPlugin extends AbstractFormPlugin{

	private final String APPROVALRECORD = "approvalrecord";
	
	@Override
	public void afterCreateNewData(EventObject e) {
		super.afterCreateNewData(e);
		ApprovalRecord ctrl = getControl(APPROVALRECORD);
		//设置单据ID
		ctrl.setBusinessKey("743903400525058048");
	}
}
```

##### 方法说明

方法名  | 说明 
------- | ------- 
setBusinessKey(String businessKey)  | 设置单据ID并加载审批记录数据

* 运行效果：

![审批记录控件使用效果_动态表单](./images/approvalRecord_form_show.png)


