## 苍穹登录页配置升级指南
### 适用范围

- 苍穹平台版本小于`1.5`而且已经对登录页有个性化配置的客户需要关注本指南。
- 本指南描述新的配置方式只对苍穹平台版本 `>=1.5` 适用。

### 有什么变化
私有化部署的客户大多需要对登录页有个性化配置需求，比如`更换logo`、`更换登录页大图`、`页面标题名称`等。
- 苍穹`1.0`、`1.1`、`1.2`等版本是通过手工替换资源文件或者通过扩展JS的方式动态修改，虽然功能上满足，每次补丁升级后都需要将个性化的文件重新拷贝到web镜像中，存在诸多升级更新的不便。

鉴于登录页个性化是客户普遍需要的功能，我们在苍穹`1.5`版本中将该功能单独抽出来，做成了可视化配置的方式。

- 功能入口 `应用 -> 系统管理 -> 登录页配置` 

### 如何配置

将苍穹平台版本升级到`1.5`后，<u>使用有 `管理员` 权限的用户登录系统</u>。打开 `应用 -> 系统管理 -> 登录页配置` 功能页面，可配置的内容有：
- 登录页背景图
- 登录页logo
- 登录账号信息
- 浏览器页签文字
- 浏览器页签logo
- 登录成功欢迎语 
- 首页左上角logo
- 账号输入框提示语
- 隐藏找回密码
- 记住账号密码显示配置(默认是 `显示记住账号密码`): 显示记住账号密码/显示记住账号/都不显示

![20200521095022.png](./images/20200521095022.png)

配置完成后，点击保存，提示成功后，则表示修改完成，用户重新登录即可使用最新配置信息

注意： <u>配置生效的范围是租户级别，和登录哪个帐套修改无关</u>

### 扩展JS文件配置

苍穹`1.0`、`1.1`、`1.2`等版本如需二开扩展JS文件，需修改镜像中的`webapp/public/custom`目录的`js`文件，然后重新安装新镜像。
苍穹平台版本升级到`1.5`后，配置方法如下：
- 点击`高级设置`，下载压缩包模板
- 模版中包含两个文件`index.js`（扩展web端使用）和`index_m.js`（扩展移动端使用），按照`js`里面的提示增加扩展功能即可，如是在`1.5以前`已有扩展`js`，则只需把原有内容拷贝过来即可。
- 按规则上传扩展文件压缩包，压缩包必须包含`index.js`和`index_m.js`文件，而且该两个文件需要在压缩包根目录（不能有上级文件夹）
- 保存，生效

![c9776d50c16333bd.png](./images/c9776d50c16333bd.png)

![ae9ac01921fc9734.png](./images/ae9ac01921fc9734.png)

