(function (KDApi, $) {
  function MyComponent(model) {
      this._setModel(model);
  }

  // 主题色
  var themeColor;

  MyComponent.prototype = {
      _setModel: function (model) {
          this.model = model;
      },
      init: function (props) {
          themeColor = props.themeColor
          setHtml(this.model, props);
      },
      update: function (props) {
          themeColor = props.themeColor;
          updateHtml(this.model, props);
      },
      destoryed: function () {

      }
  }

  var setHtml = function (model, props, isUpdate) {
      var cssHref = KDApi.getNameSpace(model) + './css/dellabel.css';
      if($('link[href="' + cssHref + '"]').length === 0){
          KDApi.loadFile('./css/dellabel.css', model, function() {
              updateHtml(model, props);
          })            
      }
      updateHtml(model, props);
  }

  var updateHtml = function(model, props){
      var template = '<div class="hr_delLabel" title="<%= text %>">' +
                          '<div class="hr_delLabel_text">' +
                              '<%= text %>' +
                          '</div>' +
                          '<div class="hr_delLabel_icon"></div>' +
                      '</div>';
      var result = KDApi.getHTMLStringBytemplate(template, {
          text: props.data && props.data['text'] ? props.data['text'] : props.configItems ? props.configItems[0].value : '标签'
      })
      model.dom.innerHTML = result;
      initEvent(model, props);
  }

  var initEvent = function (model, props) {
      $(model.dom).css({
          "overflow":"visible"
      })
      $('.hr_delLabel', model.dom).css({
          "width": model.dom.style.width,
          "height": model.dom.style.height,
          "font-size": model.dom.style.fontSize !== '' ? model.dom.style.fontSize : '12px',
          "text-align": model.dom.style.textAlign,
          "overflow":"visible"
      }).click(function () {
          model.invoke('click', '');
          model.invokeCustomMethod('click', [0])
      }).mouseenter(function () {
          $(this).find('.hr_delLabel_icon').css({
              "background-color": themeColor,
          }).addClass('active');
          $(this).css({
              "border-color": themeColor
          })
      }).mouseleave(function () {
          $(this).find('.hr_delLabel_icon').css({
              "background-color": "transparent"
          }).removeClass('active')
          $(this).css({
              "border-color": "#CCCCCC"
          })
      })
      $('.hr_delLabel_text', model.dom).css({
          "width": parseInt(model.dom.style.width) - 19 + 'px',
          "line-height": model.dom.style.height
      })
  }
  KDApi.register('dellabel', MyComponent)
})(window.KDApi, jQuery);