package kd.bos.business.unittest.plugin.webofficedemo;

import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.dataentity.entity.DynamicObjectCollection;
import kd.bos.dataentity.metadata.dynamicobject.DynamicObjectType;
import kd.bos.form.FormShowParameter;
import kd.bos.form.ShowType;
import kd.bos.form.control.Control;
import kd.bos.form.control.EntryGrid;
import kd.bos.form.control.Toolbar;
import kd.bos.form.control.WebOffice;
import kd.bos.form.control.events.ItemClickEvent;
import kd.bos.form.control.events.RowClickEventListener;
import kd.bos.form.plugin.AbstractFormPlugin;
import kd.bos.servicehelper.BusinessDataServiceHelper;
import kd.bos.url.UrlService;

import java.util.EventObject;

/**
 * @author rd_jihui_luo
 * @date 2020/2/25
 */
public class DocComparePlugIn extends AbstractFormPlugin implements RowClickEventListener{

    @Override
    public void afterCreateNewData(EventObject e) {
        FormShowParameter param = getView().getFormShowParameter();
//        String url1 = param.getCustomParam("url1");
//        String fileName1 = param.getCustomParam("fileName1");
//        String url2 = param.getCustomParam("url2");
//        String fileName2 = param.getCustomParam("fileName2");
//        WebOffice webOffice = getControl("webofficeap");
//        webOffice.compareFile(url1,fileName1,url2,fileName2);
        
        Object id = param.getCustomParam("id");
        DynamicObject object = BusinessDataServiceHelper.loadSingle(id,"test_wb_doc_templete");
        DynamicObjectCollection versions = object.getDynamicObjectCollection("entry_version");
		this.getModel().deleteEntryData("entryentity");
		this.getModel().batchCreateNewEntryRow("entryentity", versions.size());	
		DynamicObjectCollection entryEntity = this.getModel().getEntryEntity("entryentity");
		DynamicObjectType dt = entryEntity.getDynamicObjectType();
			
		for (int i = 0; i < versions.size(); i++) {
			DynamicObject version = versions.get(i);
			DynamicObject target = entryEntity.get(i);
			target.set(dt.getProperty("version_name"), version.get("version_name"));
			target.set(dt.getProperty("version_url"), version.get("version_url"));
			target.set(dt.getProperty("version"), version.get("version"));
		}

		

    }

    @Override
    public void itemClick(ItemClickEvent evt) {
        super.itemClick(evt);

        switch(evt.getItemKey()){
            case "baritemap1": compare();break;
        }
    }
	@Override
	public void registerListener(EventObject e) {
		super.registerListener(e);
		EntryGrid entryGrid = this.getControl("entryentity");
		entryGrid.addRowClickListener(this);

        Toolbar toolbar = getControl("toolbarap");
        toolbar.addItemClickListener(this);
	}
	
    public static FormShowParameter show(String url1, String fileName1, String url2, String fileName2){
        FormShowParameter param = new FormShowParameter();
        param.setFormId("test_wb_compare");
        param.getOpenStyle().setShowType(ShowType.Modal);
        param.setCustomParam("url1",url1);
        param.setCustomParam("fileName1",fileName1);
        param.setCustomParam("url2",url2);
        param.setCustomParam("fileName2",fileName2);
        return param;
    }
    
    private void compare(){
        EntryGrid versionGrid = getControl("entryentity");
        int[] rows = versionGrid.getSelectRows();
        if(null == rows || rows.length != 2){
            getView().showErrorNotification("请选择两个版本进行比对");
            return;
        }

        String fileName1 = (String)getModel().getValue("version_name",rows[0]);
        String url1 = (String)getModel().getValue("version_url",rows[0]);
        url1 = UrlService.getAttachmentFullUrl(url1);
        String fileName2 = (String)getModel().getValue("version_name",rows[1]);
        String url2 = (String)getModel().getValue("version_url",rows[1]);
        url2 = UrlService.getAttachmentFullUrl(url2);
        WebOffice webOffice = getControl("webofficeap");
        webOffice.compareFile(url1,fileName1,url2,fileName2);

    }
    
    
    
}
