package kd.bos.business.unittest.plugin.webofficedemo;

import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.dataentity.entity.DynamicObjectCollection;
import kd.bos.dataentity.serialization.SerializationUtils;
import kd.bos.form.FormShowParameter;
import kd.bos.form.IPageCache;
import kd.bos.form.ShowType;
import kd.bos.form.control.Toolbar;
import kd.bos.form.control.events.ItemClickEvent;
import kd.bos.form.control.events.UploadListener;
import kd.bos.form.plugin.AbstractFormPlugin;
import kd.bos.mvc.FormConfigFactory;
import kd.bos.mvc.cache.PageCache;
import kd.bos.mvc.form.helper.WebOfficeBrowserHelper;
import kd.bos.mvc.form.helper.WebOfficeBrowserParam;
import kd.bos.servicehelper.BusinessDataServiceHelper;
import kd.bos.url.UrlService;

import java.util.EventObject;
import java.util.HashMap;
import java.util.Map;

/**
 * @author rd_jihui_luo
 * @date 2020/2/26
 */
public class DocPlugIn extends AbstractFormPlugin implements UploadListener {

    @Override
    public void registerListener(EventObject e) {
        super.registerListener(e);

        Toolbar toolbar = getControl("toolbarap");
        toolbar.addItemClickListener(this);
        
    }

    @Override
    public void itemClick(ItemClickEvent evt) {
        super.itemClick(evt);

        switch(evt.getItemKey()){
            case "btn_doc": genDoc();break;
        }
    }

    private void genDoc() {
        Long id = (Long)getModel().getValue("id");
        if(null == id || 0 == id){
            getView().showErrorNotification("请先保存数据");
            return;
        }

        DynamicObject docTpl = (DynamicObject) getModel().getValue("doc_tpl");
        if(null == docTpl){
            getView().showErrorNotification("请先选择合同模板");
            return;
        }

        Long tplId = (Long)docTpl.getPkValue();

        Map<String,Object> params = new HashMap<>();
        params.put("id",id);
        params.put("tplId",tplId);

        WebOfficeBrowserParam webOfficeBrowserParam = new WebOfficeBrowserParam("test_wb_doc_detail");
        webOfficeBrowserParam.setParams(params);
        String tturl = WebOfficeBrowserHelper.buildUrl(webOfficeBrowserParam);
        getView().openUrl(tturl);
    }
}
