package kd.bos.business.unittest.plugin.webofficedemo;

import kd.bos.cache.CacheFactory;
import kd.bos.cache.TempFileCache;
import kd.bos.context.RequestContext;
import kd.bos.data.BusinessDataWriter;
import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.dataentity.entity.DynamicObjectCollection;
import kd.bos.dataentity.metadata.IDataEntityProperty;
import kd.bos.dataentity.serialization.SerializationUtils;
import kd.bos.dataentity.utils.StringUtils;
import kd.bos.entity.EntityMetadataCache;
import kd.bos.entity.MainEntityType;
import kd.bos.fileservice.FileItem;
import kd.bos.fileservice.FileService;
import kd.bos.fileservice.FileServiceFactory;
import kd.bos.form.FormShowParameter;
import kd.bos.form.ShowType;
import kd.bos.form.control.Button;
import kd.bos.form.control.Control;
import kd.bos.form.control.EntryGrid;
import kd.bos.form.control.WebOffice;
import kd.bos.form.control.events.UploadEvent;
import kd.bos.form.control.events.UploadListener;
import kd.bos.form.control.events.webOffice.WebOfficeDataListener;
import kd.bos.form.control.events.webOffice.event.*;
import kd.bos.form.control.model.WebOfficeCheckBox;
import kd.bos.form.control.model.WebOfficeDocProtectionType;
import kd.bos.form.control.model.WebOfficeFileType;
import kd.bos.form.control.model.WebOfficeMark;
import kd.bos.form.control.model.WebOfficeMergeType;
import kd.bos.form.control.model.WebOfficeTrackingType;
import kd.bos.form.events.ClosedCallBackEvent;
import kd.bos.form.events.HyperLinkClickEvent;
import kd.bos.form.events.HyperLinkClickListener;
import kd.bos.form.plugin.AbstractFormPlugin;
import kd.bos.list.events.ListRowClickListener;
import kd.bos.mservice.attachment.AttachmentType;
import kd.bos.mservice.attachment.IAttachmentService;
import kd.bos.servicehelper.BusinessDataServiceHelper;
import kd.bos.url.UrlService;
import kd.bos.web.DispatchServiceHelper;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.FileReader;
import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;
import java.io.UnsupportedEncodingException;
import java.net.URLEncoder;
import java.util.*;
import java.util.stream.Collectors;

/**
 * @author rd_jihui_luo
 * @date 2020/2/23
 */
public class DocTplEditPlugIn extends AbstractFormPlugin
        implements UploadListener, ListRowClickListener, HyperLinkClickListener, WebOfficeDataListener {
	private static final FileService fileService = FileServiceFactory.getAttachmentFileService();
    @Override
    public void afterCreateNewData(EventObject e) {
        FormShowParameter param = getView().getFormShowParameter();

        //数据缓存
        Object id = param.getCustomParam("id");
        String fileUrl = param.getCustomParam("doc_url");
        String fileName = param.getCustomParam("doc_name");
        getModel().setValue("id",id);
        getModel().setValue("file_name",fileName);
        getModel().setValue("file_url",fileUrl);
        DynamicObject object = BusinessDataServiceHelper.loadSingle(id,"test_wb_doc_templete");
        String caption = (String) object.get("current_doc_caption");
        this.getPageCache().put("caption", caption);
        if(caption==""){
        	caption="欢迎"+RequestContext.get().getUserName()+"使用";
        }
        //表格初始化
        String docNumber = param.getCustomParam("doc_number");
        initVariableGrid(docNumber);
        initDocGrid(id);
       


        //打开文档
        String docUrl = param.getCustomParam("doc_url");
              
        if(docUrl!=null&&docUrl.length()>0){
            String name = docUrl.substring(docUrl.lastIndexOf("/"));
            String[] files = name.split("\\.");
            if(files[1].equals("doc")){
            	this.getPageCache().put("opentype","word");
            }else if(files[1].equals("xls")){
            	this.getPageCache().put("opentype","excel");
            }else{
            	this.getPageCache().put("opentype","ppt");
            }
        }


        if(StringUtils.isNotBlank(docUrl)){
//            String user_agent = "Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3493.3 Safari/537.36";
//            FileService fileServer = FileServiceFactory.getAttachmentFileService();
//            String down_fileName = "D://49932baf-0ce2-4391-9917-eed31d2c9cec.doc";
//            FileOutputStream out = null;
//            BufferedReader bufferedReader = null;
//            boolean flag = false;
//            try {
//                out = new FileOutputStream(fileName); 
//                fileServer.download(docUrl,out,user_agent);
//                bufferedReader = new BufferedReader(new FileReader(fileName));
//                String str = bufferedReader.readLine();
//                if(!StringUtils.isEmpty(str)){
//
//                    if("{\"description\":\"file is not exist.\",\"status\":\"success\",\"data\":null}".equals(str)){
//                    	flag = false;
//                    }else {
//                        flag = true;
//                    }
//                }else{
//                    flag = false;
//                }
//
//            } catch (Exception e1) {
//
//            }finally {
//                if(out!=null){
//                    try {
//                        out.close();
//                    } catch (IOException e1) {
//
//                    }
//                }
//
//                if(bufferedReader!=null){
//                    try {
//                        bufferedReader.close();
//                    } catch (IOException e1) {
//
//                    }
//                }
//                
//                
//
//
//            }
            docUrl = UrlService.getAttachmentFullUrl(docUrl);
            WebOffice webOffice = getControl("webofficeap");
            webOffice.openAll(docUrl,fileName);
            webOffice.setCaption(caption);
            String userName = RequestContext.get().getUserName();
            webOffice.setTrackingMode(userName, WebOfficeTrackingType.NO_TRACE);
        

        }else{
        	this.getPageCache().put("opentype","word");
            WebOffice webOffice = getControl("webofficeap");
            webOffice.openNew(WebOfficeFileType.word);
            webOffice.setCaption(caption);
        }

    }

    private void initDocGrid(Object id) {
        DynamicObject object = BusinessDataServiceHelper.loadSingle(id,"test_wb_doc_templete");
        DynamicObjectCollection list = object.getDynamicObjectCollection("entry_variable");
        if(null != list && !list.isEmpty()){
            getModel().batchCreateNewEntryRow("entryentity_doc",list.size());
            for(int i = 0 ; i < list.size(); i++){
                DynamicObject obj = list.get(i);
                String name = obj.getString("variable_name");
                String markKey = obj.getString("variable_key");
                String markValue = obj.getString("variable_value");
                String varaible = obj.getString("variable_map");

                getModel().setValue("doc_name",name,i);
                getModel().setValue("doc_variable", varaible, i);
                getModel().setValue("doc_key", markKey, i);
                getModel().setValue("doc_value", markValue, i);
                getModel().setValue("doc_del","删除书签", i);
                getModel().setValue("doc_location","定位书签", i);
            }
        }

        DynamicObjectCollection perms = object.getDynamicObjectCollection("entity_edit_perm");
        if(null != perms && !perms.isEmpty()){
            getModel().batchCreateNewEntryRow("entity_edit",perms.size());
            for(int i = 0 ; i < perms.size(); i++){
                DynamicObject obj = perms.get(i);
                DynamicObject editor = obj.getDynamicObject("edit_user");
                String markValue = obj.getString("bookmark");

                getModel().setValue("editor",editor,i);
                getModel().setValue("edit_bookmark", markValue, i);
                getModel().setValue("edit_operation","删除书签", i);
            }
        }
    }

    @Override
    public void hyperLinkClick(HyperLinkClickEvent hyperLinkClickEvent) {
        String fieldName = hyperLinkClickEvent.getFieldName();
        int rowIndex = hyperLinkClickEvent.getRowIndex();
        switch (fieldName){
            case "operation": insertVariable(rowIndex);break;
            case "doc_del": deleteMark(rowIndex);break;
            case "doc_location": locateMark(rowIndex);break;
            case "edit_operation": delEditMark(rowIndex);break;
        }
    }

    private void delEditMark(int rowIndex) {
        String markKey = (String)getModel().getValue("edit_bookmark",rowIndex);
        WebOffice webOffice = getControl("webofficeap");
        webOffice.deleteSelectedAreaEditBookmark(markKey);

        getModel().deleteEntryRow("entity_edit", rowIndex);
    }

    private void unProtectedDoc() {
        WebOffice webOffice = getControl("webofficeap");
        webOffice.cancelProtectDoc("webofficeap");
    }

    private void protectDoc() {
        WebOffice webOffice = getControl("webofficeap");
        webOffice.protectDoc(WebOfficeDocProtectionType.ONLY_COMMENT_ALLOWED,"webofficeap");
    }

    private void showCommentdialog() {
        WebOffice webOffice = getControl("webofficeap");
        webOffice.showCommentDialog();
    }

    private void locateMark(int rowIndex) {
        String markKey = (String)getModel().getValue("doc_key",rowIndex);
        WebOffice webOffice = getControl("webofficeap");
        webOffice.locateMark(markKey);
    }

    private void deleteMark(int rowIndex) {
        String markKey = (String)getModel().getValue("doc_key",rowIndex);
        WebOffice webOffice = getControl("webofficeap");
        webOffice.deleteMarks(Arrays.asList(markKey));

        getModel().deleteEntryRow("entryentity_doc", rowIndex);
    }

    private void insertVariable(int rowIndex) {
        String name = (String)getModel().getValue("name", rowIndex);
        String key = (String)getModel().getValue("key", rowIndex);

        //插入书签列表
        int row = getModel().insertEntryRow("entryentity_doc",0);
        String markKey = key + "_" +System.currentTimeMillis();
        String markValue = "【"+name+"】";
        getModel().setValue("doc_name",name,row);
        getModel().setValue("doc_variable", key, row);
        getModel().setValue("doc_key", markKey, row);
        getModel().setValue("doc_value", markValue, row);
        getModel().setValue("doc_del","删除书签", row);
        getModel().setValue("doc_location","定位书签", row);

        WebOffice webOffice = getControl("webofficeap");

        webOffice.addMarks(new WebOfficeMark(markKey, markValue));
    }

    private void initVariableGrid(String docNumber) {
        MainEntityType mainEntity = EntityMetadataCache.getDataEntityType(docNumber);
        Map<String, IDataEntityProperty> dataMap = mainEntity.getFields();

        getModel().batchCreateNewEntryRow("entryentity",dataMap.entrySet().size());
        int i = 0;
        for (Map.Entry<String, IDataEntityProperty> entry: dataMap.entrySet()) {
            String name = entry.getValue().getDisplayName().toString();
            getModel().setValue("name",name, i);
            getModel().setValue("key",entry.getKey(),i);
            getModel().setValue("operation","插入变量",i);
            i++;
        }
    }

    @Override
    public void registerListener(EventObject e) {
        super.registerListener(e);
        addClickListeners("btn_save","btn_insert_confirm","btn_locate","btn_compare",
                "btn_comment","btn_protect","btn_unprotect","btn_limit_doc","btn_unlimit_doc","btn_edit_role",
                "btn_insert_table","btn_insert_table_mark","btn_show_trace","btn_doc_change",
                "btn_get_all_bookmark","btn_mark_check","btn_get_all_checkbox","btn_get_txt",
                "btn_checkbox_false","btn_checkbox_true","btn_add_tablecolumns",
                "btn_add_tablerows","btn_set_text_style","btn_set_selectionasfield","btn_get_isfieldrevise",
                "btn_caption","btn_set_toolbars","btn_set_titlebar","btn_set_menubar","btn_set_docasfield","btn_send_openstatus","btn_opennew","btn_opennew_excel","btn_opennew_ppt","btn_close","btn_set_toolbars_t","btn_set_titlebar_t","btn_set_menubar_t","btn_show_trace_false","btn_show","btn_show_false");

        Button uploadButton = getControl("btn_upload");
        uploadButton.addUploadListener(this);
        
        Button mergedocs = getControl("btn_mergedocs");
        mergedocs.addUploadListener(this);
        
        EntryGrid grid = getControl("entryentity");
        grid.addHyperClickListener(this);

        EntryGrid markGrid = getControl("entryentity_doc");
        markGrid.addHyperClickListener(this);

        EntryGrid editGrid = getControl("entity_edit");
        editGrid.addHyperClickListener(this);

        WebOffice webOffice = getControl("webofficeap");
        webOffice.addUploadListener(this);
        webOffice.addDataListener(this);
    }

    @Override
    public void click(EventObject evt) {
        super.click(evt);

        Control ctrl = (Control) evt.getSource();
        switch(ctrl.getKey()){
            case "btn_save": saveDoc();break;
            case "btn_insert_confirm": insertValue();break;
            case "btn_comment": showCommentdialog();break;
            case "btn_protect": protectDoc();break;
            case "btn_unprotect": unProtectedDoc();break;
            case "btn_limit_doc": limitDoc();break;
            case "btn_unlimit_doc": unlimitDoc();break;
            case "btn_edit_role": setAreaEditRole();break;
            case "btn_insert_table": addTable("cursor");break;
            case "btn_insert_table_mark": addTable("bookmark");break;
            case "btn_show": show();break;
            case "btn_show_false": show_false();break;
            case "btn_show_trace": showTracking();break;
            case "btn_show_trace_false": showTracking_false();break;
            case "btn_doc_change": checkDocChange();break;
            case "btn_get_all_bookmark": getAllBookmarks();break;
            case "btn_mark_check": bookMarkCheck();break;
            case "btn_get_txt": getTxt();break;
            case "btn_get_all_checkbox": getAllCheckbox();break;
            case "btn_checkbox_false": setCheckBox(false);break;
            case "btn_checkbox_true": setCheckBox(true);break;
            case "btn_add_tablecolumns": addTableColumns();break;
            case "btn_add_tablerows": addTableRows();break;
            case "btn_set_text_style": setTextStyle();break;
            case "btn_set_selectionasfield": addBookmarkForSelection();break;
            //case "btn_mergedocs": mergeDocs();break;
            case "btn_get_isfieldrevise": getFieldRevise();break;
            case "btn_caption": setCaption();break;
            case "btn_set_toolbars": setToolbars();break;
            case "btn_set_titlebar": setTitlebar();break;
            case "btn_set_menubar": setMenubar();break; 
            case "btn_set_docasfield": setDocAsField();break;
            case "btn_send_openstatus": sendOpenStatus();break;
            //case "btn_open_all": openAll();break;
            case "btn_opennew": openNew();break;
            case "btn_opennew_excel": openNewEXCEL();break;
            case "btn_opennew_ppt": openNewPPT();break;
            case "btn_close": close();break;
            case "btn_set_toolbars_t": setToolbars_t();break;
            case "btn_set_titlebar_t": setTitlebar_t();break;
            case "btn_set_menubar_t": setMenubar_t();break;
            //case "btn_setdoclimitbyrole": setDocLimitByRole();break;     
            default: break;
        }
    }
//    private void setDocLimitByRole() {
//    	WebOffice webOffice = getControl("webofficeap");
//    	List<String> bookmarks= new ArrayList<>();
//    	bookmarks.add("bookmark1");
//    	bookmarks.add("bookmark2");
//        webOffice.setEditableAreas(bookmarks,"123456");
//    }
    private void show() {

    	WebOffice webOffice = getControl("webofficeap");
        webOffice.setTrackingMode(RequestContext.get().getUserName(), WebOfficeTrackingType.TRACKING_EDIT);
    }
    private void show_false() {

    	WebOffice webOffice = getControl("webofficeap");
        webOffice.setTrackingMode(RequestContext.get().getUserName(), WebOfficeTrackingType.NO_TRACE);
    }
    private void close() {

    	WebOffice webOffice = getControl("webofficeap");
        webOffice.close();
    }
    private void openNew() {

    	WebOffice webOffice = getControl("webofficeap");
    	this.getPageCache().put("opentype","word");
        webOffice.openNew(WebOfficeFileType.word);
    }
    private void openNewEXCEL() {

    	WebOffice webOffice = getControl("webofficeap");
    	this.getPageCache().put("opentype","excel");
        webOffice.openNew(WebOfficeFileType.excel);
    }
    private void openNewPPT() {

    	WebOffice webOffice = getControl("webofficeap");
    	this.getPageCache().put("opentype","ppt");
        webOffice.openNew(WebOfficeFileType.ppt);
    }
    
    private void openAll() {

    	WebOffice webOffice = getControl("webofficeap");
        String currentPath = getClass().getResource(".").getFile().toString();
        //"webofficedemo/src/main/resources/docsUrl.docx"
        String url = currentPath;
        url = url.substring(1);
        url = url.replace("webofficedemo/bin/main/com/kd/demo/weboffice/", "webofficedemo/src/main/resources/docsUrl.docx");
        url = url.replace("/", "//");
        webOffice.openAll(url,"xlsxUrl.xlsx");
    }
    private void sendOpenStatus() {
        WebOffice webOffice = getControl("webofficeap");
        webOffice.sendOpenStatus();
    }
    private void setDocAsField() {
        WebOffice webOffice = getControl("webofficeap");
        webOffice.setDocAsField("bookMark");
    }
    private void setToolbars() {
        WebOffice webOffice = getControl("webofficeap");
        webOffice.setToolbars(false);
    }
    private void setTitlebar() {
        WebOffice webOffice = getControl("webofficeap");
        webOffice.setTitlebar(false);
    }
    private void setMenubar() {

        WebOffice webOffice = getControl("webofficeap");
        webOffice.setMenubar(false);
    }
    
    private void setToolbars_t() {
        WebOffice webOffice = getControl("webofficeap");
        webOffice.setToolbars(true);
    }
    private void setTitlebar_t() {
        WebOffice webOffice = getControl("webofficeap");
        webOffice.setTitlebar(true);
    }
    private void setMenubar_t() {

        WebOffice webOffice = getControl("webofficeap");
        webOffice.setMenubar(true);
    }
    
    private void setCaption() {
    	Object data = getModel().getValue("txt_msg");
        if(null == data){return;}
        WebOffice webOffice = getControl("webofficeap");
        webOffice.setCaption(data.toString()); 
        this.getPageCache().put("caption",data.toString());
    }
    private void mergeDocs() {
        WebOffice webOffice = getControl("webofficeap");
        String[] docsUrl = new String[1];
        //此处接收docsUrl
        String currentPath = getClass().getResource(".").getFile().toString();
        //"webofficedemo/src/main/resources/docsUrl.docx"
        String url = currentPath;
        url = url.substring(1);
        url = url.replace("webofficedemo/bin/main/com/kd/demo/weboffice/", "webofficedemo/src/main/resources/docsUrl.docx");
        url = url.replace("/", "//");
        docsUrl[0] = url;         
        webOffice.mergeDocs( WebOfficeMergeType.cursor,docsUrl);
        //webOffice.mergeDocsByBookmark("bookmark", docsUrl);
    }
    private void setCheckBox(boolean flag) {
        WebOffice webOffice = getControl("webofficeap");
        String checkboxId = (String)getModel().getValue("txt_checkboxid");
        if(StringUtils.isBlank(checkboxId)){
            getView().showErrorNotification("请先录入checkbox Id");
            return;
        }
        webOffice.setCheckBoxChecked(flag, checkboxId);
    }

    private void getAllCheckbox() {
        WebOffice webOffice = getControl("webofficeap");
        webOffice.getAllCheckBoxs();
    }

    private void getTxt() {
        WebOffice webOffice = getControl("webofficeap");
        String mark = (String)getModel().getValue("txt_mark");
        if(StringUtils.isBlank(mark)){
            getView().showErrorNotification("请先录入要插入表格处的书签");
            return;
        }
        webOffice.getTextByBookmark(mark);
    }
    private void getFieldRevise() {
        WebOffice webOffice = getControl("webofficeap");
        String mark = (String)getModel().getValue("txt_mark");
        if(StringUtils.isBlank(mark)){
            getView().showErrorNotification("请先录入要插入表格处的书签");
            return;
        }
        webOffice.sendIsFieldRevise(mark);
    }

    private void bookMarkCheck() {
        WebOffice webOffice = getControl("webofficeap");
        String mark = (String)getModel().getValue("txt_mark");
        if(StringUtils.isBlank(mark)){
            getView().showErrorNotification("请先录入要插入表格处的书签");
            return;
        }
        webOffice.checkBookmark(mark);
    }

    private void getAllBookmarks() {
        WebOffice webOffice = getControl("webofficeap");
        webOffice.getAllBookmarks();
    }

    private void checkDocChange() {
        WebOffice webOffice = getControl("webofficeap");
        webOffice.isDocChanged(); 
    }

    private void setTextStyle() {

    	WebOffice webOffice = getControl("webofficeap");
    	String type = (String) this.getModel().getValue("type");
    	if(type!=null&&type.length()>0){
    		webOffice.setTextStyle("bookmark", type);
    	}else{
    		this.getView().showMessage("请先选择标题类别");
    	}


    }
    private void addBookmarkForSelection() {

    	WebOffice webOffice = getControl("webofficeap");
    	webOffice.addBookmarkForSelection("bookmark");
    	this.getView().showSuccessNotification("添加书签成功！");
    }
    private void addTableColumns() {

    	WebOffice webOffice = getControl("webofficeap");
        String[][] tableDatas = {
                {"性别","男","女"},
                {"身高","177","155"}
        };
    	webOffice.addTableColumns("cursor", tableDatas );
    }
    private void addTableRows() {

    	WebOffice webOffice = getControl("webofficeap");
        String[][] tableDatas = {
                {"4","李六","18"},
                {"5","吴七","18"}
        };
    	webOffice.addTableRows("cursor", tableDatas );
    }
    private void showTracking() {
        WebOffice webOffice = getControl("webofficeap");
        String userName = RequestContext.get().getUserName();
        webOffice.showTracesBy(userName, true);
    }
    private void showTracking_false() {
        WebOffice webOffice = getControl("webofficeap");
        String userName = RequestContext.get().getUserName();
        webOffice.showTracesBy(userName, false);
    }

    private void addTable(String type) {
        String[][] tableDatas = {			
                {"编号","姓名","年龄"},
                {"1","张三","18"},
                {"2","李四","20"},
                {"3","王五","19"}
        };

        WebOffice webOffice = getControl("webofficeap");
        if("bookmark".equals(type)){
            String mark = (String)getModel().getValue("txt_mark");
            if(StringUtils.isBlank(mark)){
                getView().showErrorNotification("请先录入要插入表格处的书签");
                return;
            }
            webOffice.addTable(tableDatas);
        }else{
            webOffice.addTable(tableDatas);
        }

    }

    private void setAreaEditRole() {
        DynamicObject user = (DynamicObject) getModel().getValue("edit_user");
        if(null == user){
            getView().showErrorNotification("请先选择一个用户");
            return;
        }

        Object id = user.getPkValue();
        String mark = "user_" + id + "_" +new Random().nextInt(10000);
        int row = getModel().insertEntryRow("entity_edit",0);
        getModel().setValue("editor", id, row);
        getModel().setValue("edit_bookmark", mark, row);
        getModel().setValue("edit_operation","删除书签", row);

        WebOffice webOffice = getControl("webofficeap");
        webOffice.setSelectedAreaEditBookmark(mark);
    }

    private void limitDoc() {
        WebOffice webOffice = getControl("webofficeap");
        webOffice.limitDoc("webofficeap");
    }

    private void unlimitDoc() {
        WebOffice webOffice = getControl("webofficeap");
        webOffice.unLimitDoc("webofficeap");
    }

    private void saveDoc() {
    	String caption = this.getPageCache().get("caption");
        String name = (String)getModel().getValue("name");
        if(StringUtils.isBlank(name)){
            getView().showErrorNotification("文件名不能为空");
            return;
        }

        WebOffice webOffice = getControl("webofficeap");
        webOffice.save(name);
        this.getPageCache().put("caption",caption);
        
    }

    @Override
    public void closedCallBack(ClosedCallBackEvent closedCallBackEvent) {
        super.closedCallBack(closedCallBackEvent);
    }

    private void insertValue() {
        Object data = getModel().getValue("txt_msg");
        if(null == data){return;}

        WebOffice webOffice = getControl("webofficeap");
        webOffice.insertValue(data.toString(),true);
    }

    @Override
    public void afterUpload(UploadEvent evt) {
    	String type = this.getPageCache().get("opentype");
    	String caption = this.getPageCache().get("caption");
        Object[] urls = evt.getUrls();
        if(null == urls || urls.length == 0){
            getView().showErrorNotification("请上传文档");
            return;
        }

        Object urlData = urls[0];
        String filePath = "";
        String fileName = "";
        String url = "";
        if(urlData instanceof String){
            filePath = urlData.toString();
            fileName = filePath.substring(filePath.lastIndexOf("/"));
            String[] files = fileName.split("\\.");
            String tFileName = files.length == 2 ? files[0] : UUID.randomUUID().toString();
            try {
            	tFileName = URLEncoder.encode(tFileName, "utf-8");
			} catch (UnsupportedEncodingException e) {
				e.printStackTrace();
			}
            
            String tExtend = files.length == 2 ? files[1] : "doc";
            fileName = tFileName + "." + tExtend;
            
            url = filePath;
        }else if(urlData instanceof Map){
            filePath = ((Map<String,Object>) urlData).get("url").toString();
            fileName = UUID.randomUUID().toString();
            url = filePath;
        }

        if(url.contains("tempfile")){
            TempFileCache cache = CacheFactory.getCommonCacheFactory().getTempFileCache();
            InputStream in = cache.getInputStream(url);
            FileService service = FileServiceFactory.getAttachmentFileService();
            String suffix = ".doc"; 
            if(type!=null){
                if(type.equals("excel")){
                	suffix = ".xls";
                }else if(type.equals("word")){
                	suffix = ".doc";
                }else if(type.equals("ppt")){
                	suffix = ".ppt";
                }
            }
            this.getPageCache().remove("opentype");
            String path = "/webofficedemo_" + System.currentTimeMillis() + "/" + fileName + suffix;
            try {
				fileName = URLEncoder.encode(fileName, "utf-8");
			} catch (UnsupportedEncodingException e) {
				e.printStackTrace();
			}
            fileName = fileName + suffix;
            FileItem fileItem = new FileItem(fileName, path, in);
            fileItem.setCreateNewFileWhenExists(true);
            String turl = service.upload(fileItem);
            cache.remove(url);
            url = turl;
        }

        getModel().setValue("file_name",fileName);
        getModel().setValue("file_url",url);
        

        String key = evt.getCallbackKey(); 
        if("btn_upload".equals(key)){
            WebOffice webOffice = getControl("webofficeap");
            String tUrl = UrlService.getAttachmentFullUrl(url);
            String name = tUrl.substring(tUrl.lastIndexOf("/"));
            String[] files = name.split("\\.");
            String tFileName = files.length == 2 ? files[0] : UUID.randomUUID().toString();
            try {
            	tFileName = URLEncoder.encode(tFileName, "utf-8");
			} catch (UnsupportedEncodingException e) {
				e.printStackTrace();
			}
            
            String tExtend = files.length == 2 ? files[1] : "doc";
            name = tFileName + "." + tExtend;
            tUrl = tUrl.substring(0, tUrl.lastIndexOf("/"));
            tUrl = tUrl+name;
            webOffice.openAll(tUrl,name);
            String userName = RequestContext.get().getUserName();
            webOffice.setTrackingMode(userName, WebOfficeTrackingType.NO_TRACE);
        }else if("btn_mergedocs".equals(key)){
            WebOffice webOffice = getControl("webofficeap");
            String tUrl = UrlService.getAttachmentFullUrl(url);
            String name = tUrl.substring(tUrl.lastIndexOf("/"));
            String[] files = name.split("\\.");
            String tFileName = files.length == 2 ? files[0] : UUID.randomUUID().toString();
            try {
            	tFileName = URLEncoder.encode(tFileName, "utf-8");
			} catch (UnsupportedEncodingException e) {
				e.printStackTrace();
			}
            
            String tExtend = files.length == 2 ? files[1] : "doc";
            name = tFileName + "." + tExtend;
            tUrl = tUrl.substring(0, tUrl.lastIndexOf("/"));
            tUrl = tUrl+name;
            String[] docsUrl = new String[1];
            docsUrl[0] = tUrl;
            webOffice.mergeDocs(WebOfficeMergeType.cursor, docsUrl);;
            String userName = RequestContext.get().getUserName();
            webOffice.setTrackingMode(userName, WebOfficeTrackingType.NO_TRACE);
        }else if("webofficeap".equals(key)){
            DynamicObjectCollection bookMarks = getModel().getEntryEntity("entryentity_doc");

            //保存数据
            Long id = (Long)this.getModel().getValue("id");

            DynamicObject object = BusinessDataServiceHelper.loadSingle(id,"test_wb_doc_templete");
            //更新filename
            object.set("current_doc_url", url);
            object.set("current_doc_name", fileName);
            //文件标题
            object.set("current_doc_caption", caption);

            //添加版本
            DynamicObjectCollection versions = object.getDynamicObjectCollection("entry_version");
            int versionCode = versions == null || versions.isEmpty() ? 1 : versions.get(versions.size()-1).getInt("version") + 1;
            DynamicObject version = new DynamicObject(versions.getDynamicObjectType());
            version.set("version_name", fileName);
            version.set("version_url", url);
            version.set("version", versionCode);
            version.set("seq",versionCode);
            versions.add(version);
            //sBusinessDataWriter.save(versions.getDynamicObjectType(), versions.toArray());

            //更新书签
            DynamicObjectCollection list = object.getDynamicObjectCollection("entry_variable");
            list.clear();
            int index = 1;
            for(DynamicObject mark : bookMarks){
                DynamicObject obj = new DynamicObject(list.getDynamicObjectType());
                obj.set("variable_name", mark.get("doc_name"));
                obj.set("variable_key",mark.get("doc_key"));
                obj.set("variable_value",mark.get("doc_value"));
                obj.set("variable_map",mark.get("doc_variable"));
                obj.set("seq",index++);
                list.add(obj);
            }

            //更新权限书签
            DynamicObjectCollection permMarks = getModel().getEntryEntity("entity_edit");
            DynamicObjectCollection perms = object.getDynamicObjectCollection("entity_edit_perm");
            perms.clear();
            index = 1;
            for(DynamicObject mark : permMarks){
                DynamicObject obj = new DynamicObject(perms.getDynamicObjectType());
                obj.set("edit_user", mark.get("editor"));
                obj.set("bookmark",mark.get("edit_bookmark"));
                obj.set("seq",index++);
                perms.add(obj);
            }

            BusinessDataWriter.save(object.getDynamicObjectType(), new Object[]{object});
            getView().showSuccessNotification("保存成功");
        }
    }


    public static FormShowParameter show(Long id, String docNumber, String docUrl, String docName){
        FormShowParameter param = new FormShowParameter();
        param.setFormId("test_wb_tpl_edit");
        param.getOpenStyle().setShowType(ShowType.Modal);
        param.setCustomParam("id",id);
        param.setCustomParam("doc_number",docNumber);
        param.setCustomParam("doc_url",docUrl);
        param.setCustomParam("doc_name",docName);
        return param;
    }

    @Override
    public void onGetDocChangeCheckResult(WebOfficeDocChangeEvent event) {
        getView().showSuccessNotification("收到文档变动通知，当前文档变动状态为：" + event.isChanged());
    }

    @Override
    public void onGetAllBookmarks(WebOfficeBookmarkEvent event) {
        getView().showSuccessNotification("收到获取全部书签，目前书签共有：" + SerializationUtils.toJsonString(event.getBookmarks()));
    }

    @Override
    public void onGetBookmarkCheckResult(WebOfficeBookmarkCheckEvent event) {
        getView().showSuccessNotification("收到获取书签检测，书签为：" + event.getBookmark() + ",检测结果为："  + event.isExist());
    }

    @Override
    public void onGetTextByBookmark(WebOfficeBookmarkValueEvent event) {
        getView().showSuccessNotification("收到获取书签文本，书签为：" + event.getBookmark() + ",获取结果为："  + event.getValue());
    }
    @Override
    public void onGetAllCheckBoxes(WebOfficeCheckboxEvent event) {

        getView().showMessage("收到获取全部checkbox，目前共有：" + SerializationUtils.toJsonString(event.getCheckBoxes()));
    }
    
    @Override
    public void onIsFieldRevise(WebOfficeIsFieldReviseEvent event) {
        getView().showSuccessNotification("是否修订：" + SerializationUtils.toJsonString(event.isFieldRevise()));
    }

	@Override
	public void onSendOpenStatus(WebOfficeOpenStatusEvent event) {
		getView().showSuccessNotification("文档状态：" + event.isOpen());
		
	}

	

}
