package kd.bos.business.unittest.plugin.webofficedemo;

import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.dataentity.entity.DynamicObjectCollection;
import kd.bos.dataentity.utils.StringUtils;
import kd.bos.form.FormShowParameter;
import kd.bos.form.control.Control;
import kd.bos.form.control.EntryGrid;
import kd.bos.form.control.WebOffice;
import kd.bos.form.control.events.ItemClickEvent;
import kd.bos.form.events.ClosedCallBackEvent;
import kd.bos.form.plugin.AbstractFormPlugin;
import kd.bos.mvc.form.helper.WebOfficeBrowserHelper;
import kd.bos.mvc.form.helper.WebOfficeBrowserParam;
import kd.bos.servicehelper.BusinessDataServiceHelper;
import kd.bos.url.UrlService;

import java.util.EventObject;
import java.util.HashMap;
import java.util.Map;

/**
 * @author rd_jihui_luo
 * @date 2020/2/22
 */
public class DocTplPlugIn extends AbstractFormPlugin{

    @Override
    public void registerListener(EventObject e) {
        super.registerListener(e);
        addClickListeners("btn_compare");
        addClickListeners("btn_compare1");
        addItemClickListeners("toolbarap");
    }

    @Override
    public void click(EventObject evt) {
        super.click(evt);
        Control ctrl = (Control) evt.getSource();
        switch(ctrl.getKey()){
            case "btn_compare": compareDoc();break;
            case "btn_compare1": openCompareDoc();break;
            default: break;
        }
    }
    private void openCompareDoc() {
        Long id = (Long)this.getModel().getValue("id");
    	Map<String,Object> customParams = new HashMap<>();
        customParams.put("id",id);
        WebOfficeBrowserParam webOfficeBrowserParam = new WebOfficeBrowserParam("test_wb_compare");
        webOfficeBrowserParam.setParams(customParams);
        String url = WebOfficeBrowserHelper.buildUrl(webOfficeBrowserParam);
        getView().openUrl(url);
    }
    private void compareDoc() {
        EntryGrid versionGrid = getControl("entry_version");
        int[] rows = versionGrid.getSelectRows();
        if(null == rows || rows.length != 2){
            getView().showErrorNotification("请选择两个版本进行比对");
            return;
        }

        String fileName1 = (String)getModel().getValue("version_name",rows[0]);
        String url1 = (String)getModel().getValue("version_url",rows[0]);
        url1 = UrlService.getAttachmentFullUrl(url1);
        String fileName2 = (String)getModel().getValue("version_name",rows[1]);
        String url2 = (String)getModel().getValue("version_url",rows[1]);
        url2 = UrlService.getAttachmentFullUrl(url2);
        FormShowParameter param = DocComparePlugIn.show(url1,fileName1,url2,fileName2);
        getView().showForm(param);
    }

    @Override
    public void itemClick(ItemClickEvent evt) {
        super.itemClick(evt);
        switch (evt.getItemKey()){
            case "btn_doc": showDocEdit();break;
        }
    }
  
    private void showDocEdit() {
        Long id = (Long)this.getModel().getValue("id");
        if(null == id || 0 == id){
            this.getView().showTipNotification("请先保存模板数据");
            return;
        }

        Object doc = this.getModel().getValue("doc");
        String docNumber = doc == null ? "" : ((DynamicObject)doc).getString("number");
        if(StringUtils.isBlank(docNumber)){
            this.getView().showTipNotification("请选择适用合同");
            return;
        }

        String docUrl = (String)getModel().getValue("current_doc_url");
        String docName = (String)getModel().getValue("current_doc_name");
        //FormShowParameter param = DocTplEditPlugIn.show(id,docNumber, docUrl, docName);
        //param.setCloseCallBack(new CloseCallBack(this, "doc_tpl_edit"));
        //getView().showForm(param);

        //
        
		EntryGrid entrygrid = this.getView().getControl("entry_version");
		int[] s = entrygrid.getEntryState().getSelectedRows();
		if(s.length==1){
			docName = (String) this.getModel().getValue("version_name", s[0]);
			docUrl = (String) this.getModel().getValue("version_url", s[0]);
		}else if(s.length==0){

		}
		

		

        //String tturl = WebOfficeBrowserHelper.buildFormUrl("test_wb_tpl_edit", param.getCustomParams());
        Map<String,Object> customParams = new HashMap<>();
        customParams.put("id",id);
        customParams.put("doc_number",docNumber);
        customParams.put("doc_url",docUrl);
        customParams.put("doc_name",docName);

        WebOfficeBrowserParam webOfficeBrowserParam = new WebOfficeBrowserParam("test_wb_tpl_edit");
        webOfficeBrowserParam.setParams(customParams);
        String url = WebOfficeBrowserHelper.buildUrl(webOfficeBrowserParam);
        getView().openUrl(url);
    }

    @Override
    public void closedCallBack(ClosedCallBackEvent closedCallBackEvent) {
        super.closedCallBack(closedCallBackEvent);
    }
}
